/*
 Open Project By Open Platform Base Team. 
 Copyright 1998 - 2012
*/
define('$', function(){
	var xTouch;
	(function(b) {
		var a = {
			extend: function(f, e, c) {
				for (var d in e) {
					f[d] = c ? e[d] : f.hasOwnProperty(d) ? f[d] : e[d]
				}
				return f
			},
			getArgType: function(d, c) {
				if (arguments.length < 1) {
					return -1
				}
				var f = typeof d;
				var e = typeof c;
				if (f === "string" && e === "undefined") {
					return 0
				}
				if (f === "object") {
					return 2
				}
				if (f === "string" && (e === "string" || e === "number")) {
					return 1
				}
				return -1
			},
			setStyle: function(e, d, c) {
				if (d.indexOf("-") !== -1) {
					d = d.replace(/\-[a-z]/g, function(f) {
						return f[1].toUpperCase()
					})
				}
				e.style[d] = c
			},
			getStyle: function(d, c) {
				c = c.replace(/[A-Z]/g, function(e) {
					return "-" + e.toLowerCase()
				});
				return document.defaultView.getComputedStyle(d, "").getPropertyValue(c)
			},
			css: function(e, d, c) {
				return a.attrHandler(e, d, c, a.getStyle, a.setStyle)
			},
			attr: function(e, d, c) {
				return a.attrHandler(e, d, c, a.handler.attrRead, a.handler.attrWrite)
			},
			handler: {
				attrRead: function(d, c) {
					return d.getAttribute(c)
				},
				attrWrite: function(e, d, c) {
					e.setAttribute(d, c)
				}
			},
			attrHandler: function(h, d, l, g, f) {
				var c = a.getArgType(d, l),
					m;
				if (c === 0) {
					m = (h.length >= 0) ? h[0] : h;
					return m ? g(m, d) : null
				}
				if (h.length >= 0) {
					for (var e = 0; e < h.length; e++) {
						m = h[e];
						if (c === 2) {
							for (var j in d) {
								f(m, j, d[j])
							}
						} else {
							f(m, d, l)
						}
					}
				} else {
					if (c === 2) {
						for (var j in d) {
							f(h, j, d[j])
						}
					} else {
						f(h, d, l)
					}
				}
				return h
			},
			valHooks: {
				select: {
					get: function(f) {
						var c = [],
							d = f.options;
						for (var e = 0; e < d.length; e++) {
							if (d[e].selected) {
								c.push(d[e].value)
							}
						}
						if (c.length == 1) {
							return c[0]
						} else {
							if (c.length == 0) {
								return null
							} else {
								return c
							}
						}
					},
					set: function(g, c) {
						var d = g.options;
						var f = g.getAttribute("multiple") ? true : false;
						for (var e = 0; e < d.length; e++) {
							var h = d[e];
							h.selected = false;
							if (f) {
								if (xTouch.inArray(c, h.value)) {
									h.selected = true
								}
							} else {
								if (c == h.value) {
									h.selected = true;
									return
								}
							}
						}
					}
				}
			},
			dataset: function(d, c) {
				if (d.dataset) {
					return d.dataset[c]
				} else {
					return d.getAttribute("data-" + c)
				}
			},
			overWriteClass: function(e, c) {
				e && (e.className = c);
			},
			hasClass: function(e, c) {
				var d = " " + c + " ";
				if ((" " + e.className + " ").indexOf(d) != -1) {
					return true
				}
				return false
			},
			addClass: function(f, d) {
				var g = d.split(" "),
					e;
				e = xTouch.trim(f.className);
				if (!f.className) {
					f.className = d;
					return
				}
				e = " " + e + " ";
				for (var c = 0; c < g.length; c++) {
					if (e.indexOf(" " + g[c] + " ") == -1) {
						e += g[c] + " "
					}
				}
				f.className = xTouch.trim(e)
			},
			removeClass: function(e, c) {
				var d = e.className;
				if (d) {
					e.className = xTouch.trim(d.replace(c, "").replace(/[ ]+/g, " "))
				}
			},
			toggleClass: function(d, c) {
				if (a.hasClass(d, c)) {
					a.removeClass(d, c)
				} else {
					a.addClass(d, c)
				}
			}
		};
		xTouch = function(d, c) {
			return new xTouch.fn.find(d, c)
		};
		xTouch._instance = function(c) {
			if (c && c.length) {
				for (var d = 0; d < c.length; d++) {
					this[d] = c[d]
				}
				this.length = c.length
			}
			return this
		};
		xTouch._emptyArray = [];
		xTouch.getEmptyArray = function() {
			xTouch._emptyArray.length = 0;
			return xTouch._emptyArray
		};
		xTouch.fn = xTouch.prototype = {
			length: 0,
			selector: "",
			find: function(g, f) {
				var c = xTouch.getEmptyArray();
				if (!g && !this.length) {
					return new xTouch._instance()
				}
				if (g && (g.nodeType || g === window)) {
					c[0] = g;
					return new xTouch._instance(c)
				}
				if (!f && this.length) {
					var h;
					for (var e = 0; e < this.length; e++) {
						if (g) {
							h = this[e].querySelectorAll(g)
						} else {
							h = this[e].childNodes
						}
						for (var d = 0; d < h.length; d++) {
							if (h[d].nodeType === 1) {
								c.push(h[d])
							}
						}
					}
				} else {
					f = f || document;
					if (typeof g === "string") {
						c = f.querySelectorAll(g)
					}
				}
				return new xTouch._instance(c)
			},
			children: function(c) {
				if (this.length == 0) {
					return this
				}
				if (c) {
					return this.find("* > " + c)
				} else {
					return this.find()
				}
			},
			parent: function() {
				if (this.length == 0) {
					return this
				}
				var c = xTouch.getEmptyArray();
				for (var d = 0; d < this.length; d++) {
					if (this[d].nodeType === 1) {
						c.push(this[d].parentNode)
					}
				}
				return new xTouch._instance(c)
			},
			each: function(d) {
				for (var c = 0; c < this.length; c++) {
					if (d.call(this[c], c, this[c]) === false) {
						break
					}
				}
				return this
			},
			bind: function(c, e) {
				for (var d = 0; d < this.length; d++) {
					this[d].addEventListener(c, e, false)
				}
				return this
			},
			unbind: function(c, e) {
				for (var d = 0; d < this.length; d++) {
					this[d].removeEventListener(c, e, false)
				}
				return this
			}
		};
		xTouch._instance.prototype = xTouch.fn;
		xTouch.extend = xTouch.fn.extend = function(e) {
			var d = e;
			if (typeof e === "function") {
				d = e.call(null, xTouch)
			}
			if (!d) {
				return
			}
			for (var c in d) {
				xTouch.fn[c] = d[c]
			}
		};
		xTouch.ready = function(c) {
			if (document.readyState === "complete" || document.readyState === "loaded" || document.readyState === "interactive") {
				c.call(null);
				return
			} else {
				document.addEventListener("DOMContentLoaded", c, false)
			}
		};
		xTouch.extend({
			html: function(c) {
				if (c === b) {
					var e = this[0];
					return (e && e.nodeType === 1) ? this[0].innerHTML : null
				}
				for (var d = 0; d < this.length; d++) {
					this[d].innerHTML = c
				}
				return this
			},
			text: function(c) {
				if (c === b) {
					return xTouch.decodeHTML(this.html(c))
				}
				this.html(xTouch.encodeHTML(c));
				return this
			},
			val: function(c) {
				if (c === b) {
					var f = this[0];
					if (!f) {
						return null
					}
					var e = a.valHooks[f.nodeName.toLowerCase()];
					return e ? e.get(f) : f.value
				}
				for (var d = 0; d < this.length; d++) {
					var f = this[d];
					var e = a.valHooks[f.nodeName.toLowerCase()];
					if (e) {
						e.set(f, c)
					} else {
						f.value = c
					}
				}
				return this
			},
			overWriteClass: function(c) {
				for (var d = 0; d < this.length; d++) {
					a.overWriteClass(this[d], c)
				}
			},
			hasClass: function(c) {
				for (var d = 0; d < this.length; d++) {
					if (a.hasClass(this[d], c)) {
						return true
					}
				}
				return false
			},
			addClass: function(c) {
				for (var d = 0; d < this.length; d++) {
					a.addClass(this[d], c)
				}
				return this
			},
			removeClass: function(c) {
				for (var d = 0; d < this.length; d++) {
					a.removeClass(this[d], c)
				}
				return this
			},
			toggleClass: function(c) {
				for (var d = 0; d < this.length; d++) {
					a.toggleClass(this[d], c)
				}
				return this
			},
			attr: function(d, c) {
				return a.attr(this, d, c)
			},
			css: function(d, c) {
				return a.css(this, d, c)
			},
			blur: function() {
				this[0].blur();
				return this
			},
			focus: function() {
				this[0].focus();
				return this
			},
			size: function() {
				return this.length
			},
			remove: function() {
				var d;
				for (var c = 0; c < this.length; c++) {
					d = this[c];
					if (d.parentNode) {
						d.parentNode.removeChild(d)
					}
				}
				return this
			},
			append: function(f) {
				if (f === b) {
					return this
				}
				var e, d = f.nodeType;
				for (var c = 0; c < this.length; c++) {
					e = this[c];
					if (d) {
						e.appendChild(f)
					} else {
						e.innerHTML += f
					}
				}
				return this
			}
		});
		xTouch.extend({
			show: function(g) {
				var f, e, d = [];
				g = g || "block";
				for (var c = 0; c < this.length; c++) {
					f = this[c];
					e = f.style;
					if (e.display === "none") {
						e.display = ""
					}
					if (e.display === "" && a.css(f, "display") === "none") {
						d.push(f)
					}
				}
				for (var c = 0; c < d.length; c++) {
					d[c].style.display = g
				}
				return this
			},
			hide: function() {
				for (var c = 0; c < this.length; c++) {
					this[c].style.display = "none"
				}
				return this
			},
			visibility: function(c) {
				for (var d = 0; d < this.length; d++) {
					this[d].style.visibility = (c == true) ? "inherit" : "hidden"
				}
				return this
			}
		});
		xTouch.extend({
			dataset: function(c) {
				return a.dataset(this[0], c)
			}
		});
		xTouch.encodeHTML = function(c) {
			return c.replace ? c.replace(/</g, "&lt;").replace(/>/g, "&gt;") : c
		};
		xTouch.decodeHTML = function(c) {
			return c.replace ? c.replace(/&lt;/g, "<").replace(/&gt;/g, ">") : c
		};
		xTouch.inArray = function(e, c) {
			if (!e.length) {
				return e == c
			}
			for (var d = 0; d < e.length; d++) {
				if (e[d] == c) {
					return true
				}
			}
			return false
		};
		xTouch.trim = function(c) {
			if (!c) {
				return ""
			}
			if (c.trim) {
				return c.trim()
			} else {
				return c.replace(/^[\s\t ]+|[\s\t ]+$/g, "")
			}
		};
		xTouch.parseJSON = function(c) {
			if (!c) {
				return null
			}
			if (typeof c !== "string") {
				c = String(c);
			}
			if (window.JSON && window.JSON.parse) {
				try {
					return window.JSON.parse(c)
				} catch (d) {
					return (new Function("return " + xTouch.trim(c)))()
				}
			}
			return (new Function("return " + xTouch.trim(c)))()
		};
		xTouch.stringify = function(h) {
			if (window.JSON) {
				return JSON.stringify(h)
			}
			var g = typeof(h);
			if (g != "object" || h === null) {
				if (g == "string") {
					h = '"' + h + '"'
				}
				return String(h)
			} else {
				var i, e, f = [],
					c = (h && h.constructor == Array);
				var d = arguments.callee;
				for (i in h) {
					e = h[i];
					g = typeof(e);
					if (h.hasOwnProperty(i)) {
						if (g == "string") {
							e = '"' + e + '"'
						} else {
							if (g == "object" && e !== null) {
								e = d(e)
							}
						}
						f.push((c ? "" : '"' + i + '":') + String(e))
					}
				}
				return (c ? "[" : "{") + String(f) + (c ? "]" : "}")
			}
		};
		xTouch.pMethod = a
	})();
	(function() {
		var j = "tjs_views",
			h = j + "+=",
			i = ";",
			b = "+(",
			f = ")",
			e = 0;

		function k(l) {
			return l.replace(/\n/gm, "").replace(/"/gm, '\\"')
		}
		function a(l) {
			return l.replace(/(\W*)@(\w+)/gm, "$1tjs_data.$2")
		}
		function g(o, n) {
			if (o.length == 0) {
				return ""
			}
			var l = "";
			if (!n) {
				if (e === 1) {
					l = '+"' + k(o) + '"'
				} else {
					l = h + '"' + k(o) + '"'
				}
				e = 1
			} else {
				var m = o.charAt(0);
				if (m === "=") {
					if (e === 1) {
						l = b + a(o.substr(1)) + f
					} else {
						l = h + a(o.substr(1)) + i
					}
					e = 1
				} else {
					if (e === 1) {
						l = i
					}
					l += a(o);
					e = 2
				}
			}
			return l
		}
		function d(p) {
			var n = document.getElementById(p);
			if (n) {
				var l = n.innerHTML;
				var o = l.indexOf("<");
				var m = l.lastIndexOf(">");
				return l.substring(o + 4, m - 2)
			}
			return ""
		}
		var c = xTouch.tjs = function(n, q, w) {
			if (c[n]) {
				return c[n](q)
			}
			w = w || d;
			var u = w(n);
			if (!u) {
				return ""
			}
			e = 0;
			var s = "",
				v, r, o = u.length,
				m = "var tjs_views='';";
			for (var p = 0; p < o; p++) {
				v = u.charAt(p);
				switch (v) {
					case "[":
						r = u.charAt(++p);
						if (r === "%") {
							m += g(s, false);
							s = ""
						} else {
							s += v + r
						}
						break;
					case "]":
						r = u.charAt(p - 1);
						if (r === "%") {
							m += g(s.substr(0, s.length - 1), true);
							s = ""
						} else {
							s += v
						}
						break;
					default:
						s += v
				}
			}
			if (s.length !== 0) {
				m += g(s, false)
			}
			try {
				c[n] = new Function("tjs_data", m + ";return tjs_views;")
			} catch (t) {
				if ("console" in window) {
					console.log(m + ";return tjs_views;")
				}
				throw t
			}
			return c[n](q)
		}
	})();
	(function() {
		xTouch.extend({
			animate: function(c, b, f, g) {
				var h = typeof b,
					e = typeof f,
					j = (h === "number") ? b : 400,
					a = (h === "string") ? b : ((e === "string") ? f : "linear"),
				_callback = (h === "function") ? b : ((e === "function") ? f : g),
				cssValue = "all " + j + "ms " + a, count = this.length, callbacker = this, transitionEnd = function() {
					count--;
					if (count == 0) {
						for (var k = 0; k < callbacker.length; k++) {
							callbacker[k].style.removeProperty("-webkit-transition")
						}
						callbacker.unbind("webkitTransitionEnd", transitionEnd);
						if (_callback) {
							_callback.call(callbacker)
						}
					}
				};
				for (var d = 0; d < this.length; d++) {
					this[d].style["-webkit-transition"] = cssValue
				}
				this.bind("webkitTransitionEnd", transitionEnd);
				this.css(c)
			}
		})
	})();
	(function() {
		var a = {};
		xTouch.bindHashChange = function(c, b) {
			a[c] = b
		};
		xTouch.bindOtherHashChange = function(b) {
			a["__all__"] = b
		};
		xTouch.ready(function() {
			var c;

			function d() {
				var e = location.hash.match(/#([^\?]+)/);
				if (e) {
					e = e[1]
				}
				if (a[e]) {
					a[e].call(null, e)
				} else {
					if (a["__all__"]) {
						a["__all__"].call(null, e)
					}
				}
			}
			function b() {
				if (location.hash != c) {
					d();
					c = location.hash
				}
			}
			if ("onhashchange" in window) {
				window.addEventListener("hashchange", d);
				d()
			} else {
				window.setInterval(b, 200)
			}
		})
	})();
	return xTouch;
});

define("iScroll",function(){var a=Math,g=document,p=g.createElement("div").style,d=function(){var F="t,webkitT".split(","),G,m=0,H=F.length;for(;m<H;m++){G=F[m]+"ransform";if(G in p){return F[m].substr(0,F[m].length-1)}}return false}(),b=d?"-"+d.toLowerCase()+"-":"",e=f("transform"),w=f("transitionProperty"),q=f("transitionDuration"),x=f("transformOrigin"),D=f("transitionTimingFunction"),l=f("transitionDelay"),r=/android/gi.test(navigator.appVersion),s=/iphone|ipad/gi.test(navigator.appVersion),y=/hp-tablet/gi.test(navigator.appVersion),t=false,c="ontouchstart"in window&&!y,z=!!d,E=false,n="onorientationchange"in window?"orientationchange":"resize",o=c?"touchstart":"mousedown",h=c?"touchmove":"mousemove",i=c?"touchend":"mouseup",j=c?"touchcancel":"mouseup",A="mousewheel",B=function(){if(d===false){return false}var m={"":"transitionend",webkit:"webkitTransitionEnd"};return m[d]}(),C=function(){return window.requestAnimationFrame||window.webkitRequestAnimationFrame||function(m){return setTimeout(m,1)}}(),u=function(){return window.cancelRequestAnimationFrame||window.webkitCancelAnimationFrame||window.webkitCancelRequestAnimationFrame||clearTimeout}(),k=t?" translateZ(0)":"",v=function(F,H){var m=this,G;m.wrapper=typeof F=="object"?F:g.getElementById(F);m.wrapper.style.overflow="hidden";m.scroller=m.wrapper.children[0];m.options={hScroll:true,vScroll:true,x:0,y:0,bounce:true,bounceLock:false,momentum:true,lockDirection:true,useTransform:true,useTransition:false,topOffset:0,checkDOMChanges:false,handleClick:true,hScrollbar:true,vScrollbar:true,fixedScrollbar:r,hideScrollbar:s,fadeScrollbar:s&&t,scrollbarClass:"",zoom:false,zoomMin:1,zoomMax:4,doubleTapZoom:2,wheelAction:"scroll",snap:false,snapThreshold:1,onRefresh:null,onBeforeScrollStart:null,onScrollStart:null,onBeforeScrollMove:null,onScrollMove:null,onBeforeScrollEnd:null,onScrollEnd:null,onTouchEnd:null,onInit:null};for(G in H){m.options[G]=H[G]}m.x=m.options.x;m.y=m.options.y;m.options.useTransform=true;m.options.useTransition=false;m.options.hScrollbar=m.options.hScroll&&m.options.hScrollbar;m.options.vScrollbar=m.options.vScroll&&m.options.vScrollbar;m.scroller.style[w]=m.options.useTransform?b+"transform":"top left";m.scroller.style[q]="0";m.scroller.style[x]="0 0";m.options.useTransform?m.scroller.style[e]="translate("+m.x+"px,"+m.y+"px)"+k:m.scroller.style.cssText+=";position:absolute;top:"+m.y+"px;left:"+m.x+"px";m.refresh();m._bind(n,window);m._bind(o);m.options.checkDOMChanges&&(m.checkDOMTime=setInterval(function(){m._checkDOMChanges()},500));m.options.onInit&&m.options.onInit.call(m)};v.prototype={enabled:true,x:0,y:0,steps:[],scale:1,currPageX:0,currPageY:0,pagesX:[],pagesY:[],aniTime:null,wheelZoomCount:0,handleEvent:function(m){var F=this;switch(m.type){case o:if(!c&&m.button!==0){		return}F._start(m);break;case h:F._move(m);break;case i:case j:F._end(m);break;case n:F._resize();break;case B:F._transitionEnd(m);break}},_checkDOMChanges:function(){if(this.moved||this.zoomed||this.animating||this.scrollerW==this.scroller.offsetWidth*this.scale&&this.scrollerH==this.scroller.offsetHeight*this.scale){return}this.refresh()},_scrollbar:function(F){var m=this,G;if(!m[F+"Scrollbar"]){m[F+"ScrollbarWrapper"]&&(z&&(m[F+"ScrollbarIndicator"].style[e]=""),m[F+"ScrollbarWrapper"].parentNode.removeChild(m[F+"ScrollbarWrapper"]),m[F+"ScrollbarWrapper"]=null,m[F+"ScrollbarIndicator"]=null);return}!m[F+"ScrollbarWrapper"]&&(G=g.createElement("div"),m.options.scrollbarClass?G.className=m.options.scrollbarClass+F.toUpperCase():G.style.cssText="position:absolute;z-index:100;"+(F=="h"?"height:7px;bottom:1px;left:2px;right:"+(m.vScrollbar?"7":"2")+"px":"width:7px;bottom:"+(m.hScrollbar?"7":"2")+"px;top:2px;right:1px"),G.style.cssText+=";pointer-events:none;"+b+"transition-property:opacity;"+b+"transition-duration:"+(m.options.fadeScrollbar?"350ms":"0")+";overflow:hidden;opacity:"+(m.options.hideScrollbar?"0":"1"),m.wrapper.appendChild(G),m[F+"ScrollbarWrapper"]=G,G=g.createElement("div"),!m.options.scrollbarClass&&(G.style.cssText="position:absolute;z-index:100;background:rgba(0,0,0,0.5);border:1px solid rgba(255,255,255,0.9);"+b+"background-clip:padding-box;"+b+"box-sizing:border-box;"+(F=="h"?"height:100%":"width:100%")+";"+b+"border-radius:3px;border-radius:3px"),G.style.cssText+=";pointer-events:none;"+b+"transition-property:"+b+"transform;"+b+"transition-timing-function:cubic-bezier(0.33,0.66,0.66,1);"+b+"transition-duration:0;"+b+"transform: translate(0,0)"+k,m.options.useTransition&&(G.style.cssText+=";"+b+"transition-timing-function:cubic-bezier(0.33,0.66,0.66,1)"),m[F+"ScrollbarWrapper"].appendChild(G),m[F+"ScrollbarIndicator"]=G);F=="h"?(m.hScrollbarSize=m.hScrollbarWrapper.clientWidth,m.hScrollbarIndicatorSize=a.max(a.round(m.hScrollbarSize*m.hScrollbarSize/m.scrollerW),8),m.hScrollbarIndicator.style.width=m.hScrollbarIndicatorSize+"px",m.hScrollbarMaxScroll=m.hScrollbarSize-m.hScrollbarIndicatorSize,m.hScrollbarProp=m.hScrollbarMaxScroll/m.maxScrollX):(m.vScrollbarSize=m.vScrollbarWrapper.clientHeight,m.vScrollbarIndicatorSize=a.max(a.round(m.vScrollbarSize*m.vScrollbarSize/m.scrollerH),8),m.vScrollbarIndicator.style.height=m.vScrollbarIndicatorSize+"px",m.vScrollbarMaxScroll=m.vScrollbarSize-m.vScrollbarIndicatorSize,m.vScrollbarProp=m.vScrollbarMaxScroll/m.maxScrollY);m._scrollbarPos(F,true)},_resize:function(){var m=this;setTimeout(function(){m.refresh()},r?200:0)},_pos:function(m,F){m=this.hScroll?m:0;F=this.vScroll?F:0;this.scroller.style[e]="translate("+m+"px,"+F+"px) scale("+this.scale+")"+k;this.x=m;this.y=F;this._scrollbarPos("h");this._scrollbarPos("v")},_scrollbarPos:function(F,I){var m=this,G=F=="h"?m.x:m.y,H;if(!m[F+"Scrollbar"]){return}G=m[F+"ScrollbarProp"]*G;G<0?(!m.options.fixedScrollbar&&(H=m[F+"ScrollbarIndicatorSize"]+a.round(G*3),H<8&&(H=8),m[F+"ScrollbarIndicator"].style[F=="h"?"width":"height"]=H+"px"),G=0):G>m[F+"ScrollbarMaxScroll"]&&(!m.options.fixedScrollbar?(H=m[F+"ScrollbarIndicatorSize"]-a.round((G-m[F+"ScrollbarMaxScroll"])*3),H<8&&(H=8),m[F+"ScrollbarIndicator"].style[F=="h"?"width":"height"]=H+"px",G=m[F+"ScrollbarMaxScroll"]+(m[F+"ScrollbarIndicatorSize"]-H)):G=m[F+"ScrollbarMaxScroll"]);m[F+"ScrollbarWrapper"].style[l]="0";m[F+"ScrollbarWrapper"].style.opacity=I&&m.options.hideScrollbar?"0":"1";m[F+"ScrollbarIndicator"].style[e]="translate("+(F=="h"?G+"px,0)":"0,"+G+"px)")+k},_start:function(F){var m=this,J=c?F.touches[0]:F,G,H,I,K,L;if(!m.enabled){return}m.options.onBeforeScrollStart&&m.options.onBeforeScrollStart.call(m,F);m.moved=false;m.animating=false;m.zoomed=false;m.distX=0;m.distY=0;m.absDistX=0;m.absDistY=0;m.dirX=0;m.dirY=0;m.options.momentum&&(G=getComputedStyle(m.scroller,null)[e].replace(/[^0-9\-.,]/g,"").split(","),H=+G[4],I=+G[5],(H!=m.x||I!=m.y)&&(u(m.aniTime),m.steps=[],m._pos(H,I),m.options.onScrollEnd&&m.options.onScrollEnd.call(m,F)));m.absStartX=m.x;m.absStartY=m.y;m.startX=m.x;m.startY=m.y;m.pointX=J.pageX;m.pointY=J.pageY;m.startTime=F.timeStamp||Date.now();m.options.onScrollStart&&m.options.onScrollStart.call(m,F);m._bind(h,window);m._bind(i,window);m._bind(j,window)},_move:function(H){var m=this,K=c?H.touches[0]:H,F=K.pageX-m.pointX,G=K.pageY-m.pointY,I=m.x+F,J=m.y+G,M,N,O,L=H.timeStamp||Date.now();m.options.onBeforeScrollMove&&m.options.onBeforeScrollMove.call(m,H);(m.hScroll&&Math.abs(F)>Math.abs(G)||m.vScroll&&Math.abs(F)<Math.abs(G))&&H.preventDefault();m.pointX=K.pageX;m.pointY=K.pageY;(I>0||I<m.maxScrollX)&&(I=m.options.bounce?m.x+F/2:I>=0||m.maxScrollX>=0?0:m.maxScrollX);(J>m.minScrollY||J<m.maxScrollY)&&(J=m.options.bounce?m.y+G/2:J>=m.minScrollY||m.maxScrollY>=0?m.minScrollY:m.maxScrollY);m.distX+=F;m.distY+=G;m.absDistX=a.abs(m.distX);m.absDistY=a.abs(m.distY);if(m.absDistX<6&&m.absDistY<6){return}m.options.lockDirection&&(m.absDistX>m.absDistY+5?(J=m.y,G=0):m.absDistY>m.absDistX+5&&(I=m.x,F=0));m.moved=true;m._pos(I,J);m.dirX=F>0?-1:F<0?1:0;m.dirY=G>0?-1:G<0?1:0;L-m.startTime>300&&(m.startTime=L,m.startX=m.x,m.startY=m.y);m.options.onScrollMove&&m.options.onScrollMove.call(m,H)},_end:function(F){if(c&&F.touches.length!==0){return}var m=this,M=c?F.changedTouches[0]:F,J,N,K={dist:0,time:0},L={dist:0,time:0},R=(F.timeStamp||Date.now())-m.startTime,G=m.x,H=m.y,O,P,Q,I,S;m._unbind(h,window);m._unbind(i,window);m._unbind(j,window);m.options.onBeforeScrollEnd&&m.options.onBeforeScrollEnd.call(m,F);if(!m.moved){c&&this.options.handleClick&&(m.doubleTapTimer=setTimeout(function(){m.doubleTapTimer=null;J=M.target;while(J.nodeType!=1){J=J.parentNode}J.tagName!="SELECT"&&J.tagName!="INPUT"&&J.tagName!="TEXTAREA"&&(N=g.createEvent("MouseEvents"),N.initMouseEvent("click",true,true,F.view,1,M.screenX,M.screenY,M.clientX,M.clientY,F.ctrlKey,F.altKey,F.shiftKey,F.metaKey,0,null),N._fake=true,J.dispatchEvent(N))},m.options.zoom?250:0));m._resetPos(400);m.options.onTouchEnd&&m.options.onTouchEnd.call(m,F);return}R<300&&m.options.momentum&&(K=G?m._momentum(G-m.startX,R,-m.x,m.scrollerW-m.wrapperW+m.x,m.options.bounce?m.wrapperW:0):K,L=H?m._momentum(H-m.startY,R,-m.y,m.maxScrollY<0?m.scrollerH-m.wrapperH+m.y-m.minScrollY:0,m.options.bounce?m.wrapperH:0):L,G=m.x+K.dist,H=m.y+L.dist,(m.x>0&&G>0||m.x<m.maxScrollX&&G<m.maxScrollX)&&(K={dist:0,time:0}),(m.y>m.minScrollY&&H>m.minScrollY||m.y<m.maxScrollY&&H<m.maxScrollY)&&(L={dist:0,time:0}));if(K.dist||L.dist){Q=a.max(a.max(K.time,L.time),10);m.options.snap&&(O=G-m.absStartX,P=H-m.absStartY,a.abs(O)<m.options.snapThreshold&&a.abs(P)<m.options.snapThreshold?m.scrollTo(m.absStartX,m.absStartY,200):(I=m._snap(G,H),G=I.x,H=I.y,Q=a.max(I.time,Q)));m.scrollTo(a.round(G),a.round(H),Q);m.options.onTouchEnd&&m.options.onTouchEnd.call(m,F);return}if(m.options.snap){O=G-m.absStartX;P=H-m.absStartY;a.abs(O)<m.options.snapThreshold&&a.abs(P)<m.options.snapThreshold?m.scrollTo(m.absStartX,m.absStartY,200):(I=m._snap(m.x,m.y),(I.x!=m.x||I.y!=m.y)&&m.scrollTo(I.x,I.y,I.time));m.options.onTouchEnd&&m.options.onTouchEnd.call(m,F);return}m._resetPos(200);m.options.onTouchEnd&&m.options.onTouchEnd.call(m,F)},_resetPos:function(H){var m=this,F=m.x>=0?0:m.x<m.maxScrollX?m.maxScrollX:m.x,G=m.y>=m.minScrollY||m.maxScrollY>0?m.minScrollY:m.y<m.maxScrollY?m.maxScrollY:m.y;if(F==m.x&&G==m.y){m.moved&&(m.moved=false,m.options.onScrollEnd&&m.options.onScrollEnd.call(m));m.hScrollbar&&m.options.hideScrollbar&&(d=="webkit"&&(m.hScrollbarWrapper.style[l]="300ms"),m.hScrollbarWrapper.style.opacity="0");m.vScrollbar&&m.options.hideScrollbar&&(d=="webkit"&&(m.vScrollbarWrapper.style[l]="300ms"),m.vScrollbarWrapper.style.opacity="0");return}m.scrollTo(F,G,H||0)},_startAni:function(){var m=this,G=m.x,H=m.y,K=Date.now(),F,I,J;if(m.animating){return}if(!m.steps.length){m._resetPos(400);return}F=m.steps.shift();F.x==G&&F.y==H&&(F.time=0);m.animating=true;m.moved=true;J=function(){var L=Date.now(),M,N;if(L>=K+F.time){m._pos(F.x,F.y);m.animating=false;m.options.onAnimationEnd&&m.options.onAnimationEnd.call(m);m._startAni();return}L=(L-K)/F.time-1;I=a.sqrt(1-L*L);M=(F.x-G)*I+G;N=(F.y-H)*I+H;m._pos(M,N);m.animating&&(m.aniTime=C(J))};J()},_momentum:function(I,N,G,H,L){var J=0.0006,F=a.abs(I)/N,m=F*F/(2*J),M=0,K=0;I>0&&m>G?(K=L/(6/(m/F*J)),G=G+K,F=F*G/m,m=G):I<0&&m>H&&(K=L/(6/(m/F*J)),H=H+K,F=F*H/m,m=H);m=m*(I<0?-1:1);M=F/J;return{dist:m,time:a.round(M)}},_offset:function(m){var F=-m.offsetLeft,G=-m.offsetTop;while(m=m.offsetParent){F-=m.offsetLeft;G-=m.offsetTop}return{left:F,top:G}},_snap:function(H,I){var m=this,G,L,F,M,J,K;F=m.pagesX.length-1;for(G=0,L=m.pagesX.length;G<L;G++){if(H>=m.pagesX[G]){F=G;break}}F==m.currPageX&&F>0&&m.dirX<0&&F--;H=m.pagesX[F];J=a.abs(H-m.pagesX[m.currPageX]);J=J?a.abs(m.x-H)/J*500:0;m.currPageX=F;F=m.pagesY.length-1;for(G=0;G<F;G++){if(I>=m.pagesY[G]){F=G;break}}F==m.currPageY&&F>0&&m.dirY<0&&F--;I=m.pagesY[F];K=a.abs(I-m.pagesY[m.currPageY]);K=K?a.abs(m.y-I)/K*500:0;m.currPageY=F;M=a.round(a.max(J,K))||200;return{x:H,y:I,time:M}},_bind:function(m,F,G){(F||this.scroller).addEventListener(m,this,!!G)},_unbind:function(m,F,G){(F||this.scroller).removeEventListener(m,this,!!G)},destroy:function(){var m=this;m.scroller.style[e]="";m.hScrollbar=false;m.vScrollbar=false;m._scrollbar("h");m._scrollbar("v");m._unbind(n,window);m._unbind(o);m._unbind(h,window);m._unbind(i,window);m._unbind(j,window);!m.options.hasTouch&&m._unbind(A);m.options.checkDOMChanges&&clearInterval(m.checkDOMTime);m.options.onDestroy&&m.options.onDestroy.call(m)},refresh:function(){var m=this,I,G,K,J,F=0,H=0;m.scale<m.options.zoomMin&&(m.scale=m.options.zoomMin);m.wrapperW=m.wrapper.clientWidth||1;m.wrapperH=m.wrapper.clientHeight||1;m.minScrollY=-m.options.topOffset||0;m.scrollerW=a.round(m.scroller.offsetWidth*m.scale);m.scrollerH=a.round((m.scroller.offsetHeight+m.minScrollY)*m.scale);m.maxScrollX=m.wrapperW-m.scrollerW;m.maxScrollY=m.wrapperH-m.scrollerH+m.minScrollY;m.dirX=0;m.dirY=0;m.options.onRefresh&&m.options.onRefresh.call(m);m.hScroll=m.options.hScroll&&m.maxScrollX<0;m.vScroll=m.options.vScroll&&(!m.options.bounceLock&&!m.hScroll||m.scrollerH>m.wrapperH);m.hScrollbar=m.hScroll&&m.options.hScrollbar;m.vScrollbar=m.vScroll&&m.options.vScrollbar&&m.scrollerH>m.wrapperH;I=m._offset(m.wrapper);m.wrapperOffsetLeft=-I.left;m.wrapperOffsetTop=-I.top;if(typeof m.options.snap=="string"){m.pagesX=[];m.pagesY=[];J=m.scroller.querySelectorAll(m.options.snap);for(G=0,K=J.length;G<K;G++){F=m._offset(J[G]);F.left+=m.wrapperOffsetLeft;F.top+=m.wrapperOffsetTop;m.pagesX[G]=F.left<m.maxScrollX?m.maxScrollX:F.left*m.scale;m.pagesY[G]=F.top<m.maxScrollY?m.maxScrollY:F.top*m.scale}}else if(m.options.snap){m.pagesX=[];while(F>=m.maxScrollX){m.pagesX[H]=F;F=F-m.wrapperW;H++}m.maxScrollX%m.wrapperW&&(m.pagesX[m.pagesX.length]=m.maxScrollX-m.pagesX[m.pagesX.length-1]+m.pagesX[m.pagesX.length-1]);F=0;H=0;m.pagesY=[];while(F>=m.maxScrollY){m.pagesY[H]=F;F=F-m.wrapperH;H++}m.maxScrollY%m.wrapperH&&(m.pagesY[m.pagesY.length]=m.maxScrollY-m.pagesY[m.pagesY.length-1]+m.pagesY[m.pagesY.length-1])}m._scrollbar("h");m._scrollbar("v");m.scroller.style[q]="0";m._resetPos(400)},scrollTo:function(H,J,K,L){var G=this,m=H,F,I;G.stop();!m.length&&(m=[{x:H,y:J,time:K,relative:L}]);for(F=0,I=m.length;F<I;F++){m[F].relative&&(m[F].x=G.x-m[F].x,m[F].y=G.y-m[F].y);G.steps.push({x:m[F].x,y:m[F].y,time:m[F].time||0})}G._startAni()},scrollToElement:function(G,H){var F=this,m;G=G.nodeType?G:F.scroller.querySelector(G);if(!G){return}m=F._offset(G);m.left+=F.wrapperOffsetLeft;m.top+=F.wrapperOffsetTop;m.left=m.left>0?0:m.left<F.maxScrollX?F.maxScrollX:m.left;m.top=m.top>F.minScrollY?F.minScrollY:m.top<F.maxScrollY?F.maxScrollY:m.top;H=H===undefined?a.max(a.abs(m.left)*2,a.abs(m.top)*2):H;F.scrollTo(m.left,m.top,H)},scrollToPage:function(F,G,J){var m=this,H,I;J=J===undefined?400:J;m.options.onScrollStart&&m.options.onScrollStart.call(m);m.options.snap?(F=F=="next"?m.currPageX+1:F=="prev"?m.currPageX-1:F,G=G=="next"?m.currPageY+1:G=="prev"?m.currPageY-1:G,F=F<0?0:F>m.pagesX.length-1?m.pagesX.length-1:F,G=G<0?0:G>m.pagesY.length-1?m.pagesY.length-1:G,m.currPageX=F,m.currPageY=G,H=m.pagesX[F],I=m.pagesY[G]):(H=-m.wrapperW*F,I=-m.wrapperH*G,H<m.maxScrollX&&(H=m.maxScrollX),I<m.maxScrollY&&(I=m.maxScrollY));m.scrollTo(H,I,J)},stop:function(){u(this.aniTime);this.steps=[];this.moved=false;this.animating=false}};function f(m){if(d===""){return m}m=m.charAt(0).toUpperCase()+m.substr(1);return d+m}p=null;return v});define("Str",function(){var a={RegExps:{cut:/[\x00-\xFF]/,getRealLen:{r0:/[^\x00-\xFF]/g,r1:/[\x00-\xFF]/g},escHTML:{re_amp:/&/g,re_lt:/</g,re_gt:/>/g,re_apos:/'/g,re_quot:/"/g},escString:{bsls:/\\/g,sls:/\//g,nl:/\n/g,rt:/\r/g,tab:/\t/g},restXHTML:{re_amp:/&amp;/g,re_lt:/&lt;/g,re_gt:/&gt;/g,re_apos:/&(?:apos|#0?39);/g,re_quot:/&quot;/g}},cut:function(b,d,e){b=String(b);d-=0;e=e||"";if(isNaN(d)){return b}var f=b.length,c=Math.min(Math.floor(d/2),f),g=a.getRealLen(b.slice(0,c));for(;c<f&&g<d;c++){g+=1+(b.charCodeAt(c)>255)}return b.slice(0,g>d?c-1:c)+(c<f?e:"")},cutRealLen:function(b,c,d){if(a.getRealLen(b)>c){return a.cut(b,c-a.getRealLen(d),d)}return b},getRealLen:function(b,d){if(typeof b!="string"){return 0}if(!d){return b.replace(a.RegExps.getRealLen.r0,"**").length}else{var c=b.replace(a.RegExps.getRealLen.r1,"");return b.length-c.length+encodeURI(c).length/3}},escString:function(d){var b=a.RegExps.escString,c=a.RegExps.escHTML;return a.listReplace(d+"",{"\\\\":b.bsls,"\\n":b.nl,"":b.rt,"\\t":b.tab,"\\/":b.sls,"\\'":c.re_apos,'\\"':c.re_quot})},escHTML:function(c){var b=a.RegExps.escHTML;return a.listReplace(c+"",{"&amp;":b.re_amp,"&lt;":b.re_lt,"&gt;":b.re_gt,"&#039;":b.re_apos,"&quot;":b.re_quot})},escRegExp:function(b){return b.replace(/([\\\^\$\(\)\[\]\{\}\*\+\.\?\/\|])/g,"\\$1")},reEscHTML:function(c){var b=a.RegExps.restXHTML;return a.listReplace(c+"",{"<":b.re_lt,">":b.re_gt,"\x27":b.re_apos,"\x22":b.re_quot,"&":b.re_amp})},listReplace:function(b,c,d){if(require("Type").isObject(c)){require("Util").each(c,function(e,f){b=b.replace(e,f)});return b}else{return b.replace(c,d)}},tmpl:function(f,d){d=d||{};var c=["var __=[];"],e=/([\s\S]*?)(?:(?:<%([^=][\s\S]*?)%>)|(?:<%=([\s\S]+?)%>)|$)/g;e.lastIndex=0;var b=e.exec(f||"");while(b&&(b[1]||b[2]||b[3])){b[1]&&c.push("__.push('",b[1].replace(/\\/g,"\\\\").replace(/\n/g,"\\n").replace(/\r/g,"").replace(/\t/g,"\t").replace(/\//g,"\\/").replace(/'/g,"\\'").replace(/"/g,'\\"'),"');");b[2]&&c.push(b[2]);b[3]&&c.push("__.push(",b[3],");");b=e.exec(f)}c.push("return __.join('');");var g=[],h=[];for(var i in d){g.push(i);h.push(d[i])}c=new Function(g.join(","),c.join(""));return c.apply(null,h)},trim:function(b){return b.replace(/^\s+|\s+$/g,"")},escDescHTML:function(b,c){if(b){switch(c){case 0:b=b.replace(/<[!\/]?[\w-]+[^>]*>/g,"");break;case 1:b=b.replace(/<[!\/]?(?!br\b|p\b)[\w-]+[^>]*>/g,"");break}return b}}};return a});define("Type",function(){var a={is:function(c,b){var d=Object.prototype.toString.call(b).slice(8,-1);return b!==undefined&&b!==null&&d===c},isNumber:function(b){return a.is("Number",b)},isString:function(b){return a.is("String",b)},isFunction:function(b){return a.is("Function",b)},isObject:function(b){return a.is("Object",b)},isArray:function(b){return a.is("Array",b)},isBoolean:function(b){return a.is("Boolean",b)}};return a});define("Util",function(){var a={extend:function(b,c){if(!b){return c}for(var d in c){b[d]=c[d]}return b},each:function(b,d){if(!b){return false}var e,f=0;if(require("Type").isObject(b)){for(var c in b){if(d.call(b[c],b[c],c,b)===false){break}}}else{require("Type").isArray(b)&&b.forEach(function(g,h){d.call(g,g,h,b)})}return b},log:function(){require("Const").debug&&window.console&&console.log.apply(console,arguments)},logError:function(b){a.log(b.name+" : "+b.message+" \n stack :"+b.stack,b)},emptyFun:function(){},getUrlParam:function(e,f,b){var g=new RegExp("[?#&]"+e+"=([^&#]*)","i"),b=b||window.location.href,d=g.exec(b),c=d?d[1]:"";c=c.replace(/[+]/ig,"%20");return !f?decodeURIComponent(c):c},formatUsercount:function(b){b=parseInt(b,10);!isNaN(b)&&(b>=1e8?b=Math.round(b/1e8)+"亿":b<1e8&&b>=1e4?b=Math.round(b/1e4)+"万":b=b+"个");return b||0},delegate:function(b,g,e,d,c){var f=require("$");b=f(b)[0];var h=function(k){if(d&&f(b).find(d)){var i=Element.prototype,l=null,m=i.matchesSelector||i.mozMatchesSelector||i.webkitMatchesSelector||i.msMatchesSelector||i.oMatchesSelector,j=k.target;while(j!=b){if(m.call(j,d)){l=j;break}j=j.parentNode}l&&e.apply(l,[k].concat(require("Type").isArray(c)&&[c]))}else{return e.apply(k.target,[k].concat(require("Type").isArray(c)&&[c]))}};b.addEventListener(g,h,false)},addToArray:function(b,c,d){if(require("Type").isArray(b)){c=[].concat(c);a.each(c,function(e){var f=b.indexOf(e);!(-1<f)&&(!d?b.push(e):b.unshift(e))});return b}return false},removeFromArray:function(b,c){if(require("Type").isArray(b)){c=[].concat(c);a.each(c,function(e){var d=b.indexOf(e);-1<d&&b.splice(d,1)});return b}return false},formatTime:function(e){var c=parseInt((window.__responedTime-e)/1e3),d=new Date(),b=new Date(e);if(c<60){return"刚刚"}if(c<60*60){return parseInt(c/60)+"分钟前"}if(c<60*60*3){return parseInt(c/(60*60))+"小时前"}if(d.getDate()===b.getDate()){return"今天 "+b.getHours()+":"+(b.getMinutes()<10?"0":"")+b.getMinutes()}if(new Date(d.getTime()-24*60*60*1e3).getDate()===b.getDate()){return"昨天 "+b.getHours()+":"+(b.getMinutes()<10?"0":"")+b.getMinutes()}if(d.getFullYear()===b.getFullYear()){return b.getMonth()+1+"月"+b.getDate()+"日"}return b.getFullYear()+"年"+(b.getMonth()+1)+"月"+b.getDate()+"日"},hash:function(d){var b=5381;for(var c=0,e=d.length;c<e;++c){b+=(b<<5)+d.charCodeAt(c)}return b&2147483647},trigerCheckAndExecLast:function(c,d){var b=null,e=function(){try{c()}catch(f){}b=null};return function(){b&&(clearTimeout(b),b=null);b=setTimeout(e,d)}}};return a});define("Events",function(c,b){var a=function(){this.listeners={}};a.prototype={on:function(d,e){!this.listeners[d]&&(this.listeners[d]=[]);this.listeners[d].push(e)},clear:function(d){this.listeners[d]&&(this.listeners[d]=[])},emit:function(d){try{!this.listeners[d]&&(this.listeners[d]=[]);var f=this.listeners[d],h=f.length,g=Array.prototype.slice.call(arguments,1);f.forEach(function(e){e.apply(null,g)})}catch(i){}}};b.eventEmitter=a});define("TapEvent",function(){var b=document.body;function i(k){return"tagName"in k?k:k.parentNode}function c(k,l,m,n){k.addEventListener(l,m,n)}function j(k){while(k&&k!=b){var l=k.ontap;if(l instanceof Function){return{onTap:l,scope:k}}l=k.getAttribute("ontap");if(l){return{onTap:new Function("event",l),scope:k}}k=k.parentNode}}function g(l,k,m){if(!("defaultPrevented"in k)){k.defaultPrevented=false;var n=k.preventDefault;k.preventDefault=function(){this.defaultPrevented=true;n.call(this)}}k.data=m;l.dispatchEvent(k)}function h(o,k){var m=document.createEvent("Events"),n=true;if(k){for(var l in k){l=="bubbles"?n=!!k[l]:m[l]=k[l]}}m.initEvent(o,n,true,null,null,null,null,null,null,null,null,null,null,null,null);return m}var a={},e,d="";function f(){e&&clearTimeout(e);e=null;a={}}c(b,"touchstart",function(k){a.el=i(k.touches[0].target);a.x1=k.touches[0].pageX;a.y1=k.touches[0].pageY;a.isMove=false;a.start=true;a.x2=a.y2=null},true);c(b,"touchmove",function(k){a.isMove=true;a.x2=k.touches[0].pageX;a.y2=k.touches[0].pageY},true);c(b,"touchend",function(l){d=d||"touchend";var k=false;a.isMove&&a.x2&&Math.abs(a.x1-a.x2)<5&&a.y2&&Math.abs(a.y1-a.y2)<5&&(k=true);if(a.start&&(!a.isMove||k)){if(d!="touchend"){return}e=setTimeout(function(){var m=h("tap");m.cancelTouch=f;g(a.el,m)},0)}},true);c(b,"touchcancel",f,true);c(window,"scroll",f,true);c(b,"tap",function(l){var k=j(l.target);if(k){var m=k.scope.getAttribute("tapEventTimer");if(m){return}m=setTimeout(function(){k.scope.setAttribute("tapEventTimer","")},500);k.scope.setAttribute("tapEventTimer",m);var n=k.onTap.call(k.scope,l);n===false&&l.preventDefault()}},false);c(b,"click",function(k){d=d||"click";if(d!="click"){return}var l=h("tap",k);l.cancelTouch=f;g(k.target,l)},false)});define("TimeStat",function(){var a=10,c={index:{flag:"7721-159-1".split("-"),rate:a,useOpenTime:false},"index-render":{flag:"7721-159-2".split("-"),rate:a,useOpenTime:false},detail:{flag:"7721-159-3".split("-"),rate:1,useOpenTime:true},"detail-render":{flag:"7721-159-4".split("-"),rate:1,useOpenTime:true},myapp:{flag:"7721-159-5".split("-"),rate:a,useOpenTime:true},"myapp-render":{flag:"7721-159-6".split("-"),rate:a,useOpenTime:true},category:{flag:"7721-159-7".split("-"),rate:1,useOpenTime:true},"category-render":{flag:"7721-159-8".split("-"),rate:1,useOpenTime:true},info:{flag:"7721-159-9".split("-"),rate:1,useOpenTime:true},"info-render":{flag:"7721-159-10".split("-"),rate:1,useOpenTime:true},search:{flag:"7721-159-11".split("-"),rate:a,useOpenTime:false},topic:{flag:"7721-159-12".split("-"),rate:1,useOpenTime:true},"topic-render":{flag:"7721-159-13".split("-"),rate:1,useOpenTime:true},cate:{flag:"7721-159-14".split("-"),rate:1,useOpenTime:true},"cate-render":{flag:"7721-159-15".split("-"),rate:1,useOpenTime:true}},b={pingURL:"http://isdspeed.qq.com/cgi-bin/r.cgi",isReported:false,report:function(g,d,i){try{if("search"!=g&&b.isReported){return}if(!i){return setTimeout(function(){b.report(g,d,true)},3e3)}b.isReported=true;d=d||window.timestamps||[];"search"!=g&&(g+=require("R").isRender?"-render":"");var f=c[g];if(!f){return}if(Math.random()>1/f.rate){return}var h=require("Api");require("Task").create(f.useOpenTime?h.getUrlParam("openTime"):false).then(function(m){if(f.useOpenTime){var k=parseInt(m);h.setUrlParam("openTime","");if(!k){return}d.unshift(new Date(k));if(d[1]-d[0]>500){return}}if(d.length<2){return}var l=["flag1="+f.flag[0],"flag2="+f.flag[1],"flag3="+f.flag[2],"flag5="+f.rate],n=d[0];for(var e=1;e<d.length;e++){l.push(e+"="+(d[e]-n))}require("PingSender").send(b.pingURL+"?"+l.join("&"));if("search"!=g&&g.indexOf("detail")==-1){var p=91+(require("LocalStorage").support?1:0)+(require("R").isRender?1:0);require("ValueStat").report("350594",1,p,{reportRate:f.rate})}}).start()}catch(j){}}};return b});define("Task",function(e,f,c){var b=function(g){return Object.prototype.toString.call(g).slice(8,-1)=="Function"},d=function(g){window.setTimeout(g,0)};function a(g){this.msg=g;this.state=a.STATE.INIT;this.reason=null;this.async=false;this.parent=null;this.handles=[];this.children=[];this.context={}}a.STATE={INIT:0,DELEGATING:1,FULFILLED:2,REJECTED:3,FINISH:4};a.isTask=function(g){return g&&b(g.then)};a.create=function(g){return new a(g)};a.exec=function(g,h,k){g.state=k;g.msg=h;if(a.STATE.FINISH==this.state){return g}if(a.isTask(h)){a.reCall(g,h);return g}var i=g.handles.shift();if(i){var j=a.strategy[i.cmd];j&&j.call(g,i)}else{!g.async&&g.parent&&g.parent.resolve(g.msg);!g.parent&&a.destroy(g)}return g};a.reCall=function(h,g){a.isTask(g)?(h.state=a.STATE.DELEGATING,g.parent=h,h.children.push(g),a.STATE.INIT==g.state?g.start():g.resolve(g.msg)):h.resolve(g)};a.destroy=function(g){g.children.forEach(function(h){a.destroy(h)});g.destroy()};a.strategy={then:function(j){var i=a.STATE,k=j.fulfilled,h=j.rejected,g="";try{i.FULFILLED==this.state&&(g=k&&k.call(this,this.msg));i.REJECTED==this.state&&(g=h&&h.call(this,this.msg))}catch(l){this.state=i.REJECTED;this.reason=l.message;g=h&&h.call(this,l)}this.msg=g;a.reCall(this,g)},map:function(m){var n=this,g=m.map,i={},h=0,j=function(k,p){h--;i[k]=p;h==0&&a.reCall(n,i)};b(g)&&(g=g.call(this,this.msg));for(var l in g){h++;var o=g[l];(function(p,k){d(function(){b(k)||a.isTask(k)?a.create(k).then(function(q){j(p,q)}).start():j(p,k)})})(l,o)}}};a.prototype.then=function(g,h){this.handles.push({cmd:"then",fulfilled:g,rejected:h});return this};a.prototype.map=function(g){this.handles.push({cmd:"map",map:g});return this};a.prototype.resolve=function(g){if(a.STATE.FINISH==this.state){return this}return a.exec(this,g,a.STATE.FULFILLED)};a.prototype.reject=function(g){return a.exec(this,g,a.STATE.REJECTED)};a.prototype.parentResolve=function(g){this.parent&&this.parent.resolve(g);return this};a.prototype.parentReject=function(g){this.parent&&this.parent.reject(g);return this};a.prototype.start=function(){while(b(this.msg)){this.msg=this.msg.call(this)}return this.resolve(this.msg)};a.prototype.destroy=function(){this.state=a.STATE.FINISH;this.reason=null;this.parent=null;this.handles=[];this.context={}};c.exports=a});define("ImgLazyloader",function(){var b=require("Events").eventEmitter,a={isInit:false,offset:0,nodes:[],evt:new b(),on:function(){this.evt.on.apply(this.evt,arguments)},run:function(){var f=this.nodes.length;if(f>0){var j=document.documentElement.clientHeight,k=0,g=0,e=null;for(var d=k;d<f;d++){var c=this.nodes[d];imgTop=c.getBoundingClientRect().top;if(c.clientHeight>0){if(imgTop<=j+a.offset){var h=c.getAttribute("_ori_src");h&&(c.src=h,c.removeAttribute("_ori_src"),c.removeAttribute("_demand"),this.evt.emit("render",c),g++,e===null&&(e=d))}else{break}}}Array.prototype.splice.call(this.nodes,e,g)}},update:function(c){!this.isInit&&this._init();this.nodes=require("$")('img[_demand="1"]');!(c==false)?a.run():setTimeout(function(){a.run()},0)},_init:function(){if(!this.isInit){var c=null,d=function(){a.run();c=0};require("$")(window).bind("scroll",function(){c&&clearTimeout(c);c=setTimeout(d,50)});this.isInit=true}}};return a});define("DefaultData",{app:{100422914:{apkId:0,appFeature:0,appType:4,appType_sub:5011,appid_haina:1264115,id:100422914,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:7,mark_nums:339,mark_nums_all:715,migid:0,name:"水印相机",orientation:0,pName:"com.tencent.zebra",playCount:0,prelen:3,quickbar:0,secCate:"拍照",shortDes:"水印相机是国内首款智能水印应用",size:"22.0M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:5,url:"http://down.myapp.com/android_new/186/836186/16496359/com.tencent.zebra_17.apk",userCount:5884169,versionCode:17,versionName:"1.3.1.232"},100621162:{apkId:0,appFeature:0,appType:4,appType_sub:9004,appid_haina:176236,id:100621162,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:8,mark_nums:712,mark_nums_all:1533,migid:0,name:"我爱测",orientation:0,pName:"com.memoriki.iquizmobilecn",playCount:0,prelen:3,quickbar:0,secCate:"娱乐",shortDes:"",size:"2.3M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:5,url:"http://down.myapp.com/android_new/711/595711/1178784/C06A343EEB459AB7B17496540EACD778.apk",userCount:20916,versionCode:19,versionName:"2.3.7"},100631344:{apkId:0,appFeature:100631344,appType:4,appType_sub:5014,appid_haina:0,id:100631344,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:7.752480030059814,mark_nums:0,mark_nums_all:0,migid:100631344,name:"堆糖图片集",orientation:0,pName:"com.duitang.huabao.qzone",playCount:0,prelen:1,quickbar:0,secCate:"阅读",shortDes:"简约实用,全新移动浏览体验随时随地；发现和收集你喜爱的一切；在这里,重新发现生活；堆糖不止是一个网站；而是一种Lifestyle。",size:"1.6M",sourcetype:0,status:2,supportversion:"",tyqtype:3,url:"http://softfile.3g.qq.com/msoft/sqapp/duitang_qzone0803.apk",userCount:3236,versionCode:30,versionName:"1.3"},100645222:{apkId:0,appFeature:0,appType:4,appType_sub:5009,appid_haina:1160099,id:100645222,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:6,mark_nums:122,mark_nums_all:289,migid:0,name:"猜歌王",orientation:0,pName:"air.GSMobile",playCount:0,prelen:3,quickbar:0,secCate:"影音",shortDes:"热门音乐游戏，比比看谁知道的歌多",size:"10.1M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:1,url:"http://www.myapp.com/downcenter/a/784732?g_f=990935",userCount:19324933,versionCode:1004e3,versionName:"1.4.0"},100680010:{apkId:0,appFeature:0,appType:4,appType_sub:4014,appid_haina:1206644,id:100680010,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:6,mark_nums:133,mark_nums_all:345,migid:0,name:"答题王",orientation:0,pName:"com.zhtiantian.ChallengerTX",playCount:0,prelen:3,quickbar:0,secCate:"教育",shortDes:"上知天文，下知地理，智慧挑战，答题为王",size:"11.0M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:1,url:"http://www.myapp.com/downcenter/a/788298?g_f=990935",userCount:20490287,versionCode:109,versionName:"3.5.2.24"},100682088:{apkId:0,appFeature:0,appType:4,appType_sub:4014,appid_haina:1206646,id:100682088,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:5,mark_nums:9,mark_nums_all:45,migid:0,name:"疯狂答题",orientation:0,pName:"com.itboy.fkdt",playCount:0,prelen:3,quickbar:0,secCate:"教育",shortDes:"最好玩的益智答题对战游戏",size:"6.5M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:1,url:"http://www.myapp.com/downcenter/a/788301?g_f=990935",userCount:7045404,versionCode:7,versionName:"1.5"},100682801:{apkId:0,appFeature:0,appType:4,appType_sub:9004,appid_haina:1205115,id:100682801,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:6,mark_nums:5,mark_nums_all:12,migid:0,name:"百思不得姐移动",orientation:0,pName:"com.sprite.budejie.qzone",playCount:0,prelen:3,quickbar:0,secCate:"娱乐",shortDes:"每日更新内涵小漫画，热门段子",size:"2M",sourcetype:0,status:2,supportversion:"Android 2.2及以上",tyqtype:1,url:"http://www.myapp.com/downcenter/a/788133?g_f=990935",userCount:6593374,versionCode:1,versionName:"1.0"},100686842:{apkId:0,appFeature:3,appType:4,appType_sub:9022,appid_haina:0,id:100686842,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:10,mark_nums:0,mark_nums_all:0,migid:3,name:"私密日志",orientation:0,pName:"",playCount:0,prelen:0,quickbar:0,secCate:"生活",shortDes:"这是你的私密空间，你可以记下自己心里的小秘密，只有自己可见。",size:"",sourcetype:1,status:2,supportversion:"",tyqtype:4,url:"http://fwd.z.qq.com:8080/forward.jsp?bid=232&g_f=150004",userCount:70146130,versionCode:0,versionName:""},100686843:{apkId:0,appFeature:4,appType:4,appType_sub:5010,appid_haina:0,id:100686843,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:10,mark_nums:0,mark_nums_all:0,migid:4,name:"好友日志",orientation:0,pName:"",playCount:0,prelen:0,quickbar:0,secCate:"社交",shortDes:"你可以查看全部好友的日志",size:"",sourcetype:1,status:2,supportversion:"",tyqtype:4,url:"http://blog60.z.qq.com/friend_article_list.jsp",userCount:69069259,versionCode:0,versionName:""},100686850:{apkId:0,appFeature:0,appType:4,appType_sub:5014,appid_haina:112099,id:100686850,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:4,mark_nums:52,mark_nums_all:329,migid:0,name:"博雅书苑",orientation:0,pName:"com.unimob.uiface",playCount:0,prelen:3,quickbar:0,secCate:"阅读",shortDes:"",size:"2.8M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:5,url:"http://down.myapp.com/msoft/15776/50879/78897/SOFTWARE/fsbooks_v1.0.apk",userCount:87150,versionCode:1,versionName:"1.0"},100686851:{apkId:0,appFeature:0,appType:4,appType_sub:4020,appid_haina:0,id:100686851,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:8,mark_nums:160525,mark_nums_all:292625,migid:0,name:"应用宝",orientation:0,pName:"com.tencent.android.qqdownloader",playCount:0,prelen:3,quickbar:0,secCate:"系统",shortDes:"",size:"2.2M",sourcetype:0,status:5,supportversion:"2.2+",tyqtype:6,url:"http://down.myapp.com/android/50801/15706511/com.tencent.android.qqdownloader_360425.apk",userCount:197247997,versionCode:360425,versionName:"3.6.0.425"},100686853:{apkId:0,appFeature:0,appType:4,appType_sub:5014,appid_haina:10555,id:100686853,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:8,mark_nums:28202,mark_nums_all:53065,migid:0,name:"QQ阅读",orientation:0,pName:"com.qq.reader",playCount:0,prelen:3,quickbar:0,secCate:"阅读",shortDes:"培养大家读书的爱好是我不变的追求！支持全文档格式，图书种类也多，阅读体验赞。",size:"6.4M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:5,url:"http://down.myapp.com/android/46442/16697474/com.qq.reader_33.apk",userCount:45240700,versionCode:33,versionName:"4.1.0.440"},100686920:{apkId:0,appFeature:0,appType:4,appType_sub:5013,appid_haina:206354,id:100686920,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:7,mark_nums:138,mark_nums_all:319,migid:0,name:"自选股(腾讯炒股票软件)",orientation:0,pName:"com.tencent.portfolio",playCount:0,prelen:3,quickbar:0,secCate:"理财",shortDes:"企鹅出品的一款非常简约、易用的Android手机炒股软件，理财，赚钱，不是梦。",size:"6.3M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:5,url:"http://down.myapp.com/android_new/997/561997/16727909/com.tencent.portfolio_20.apk",userCount:606911,versionCode:20,versionName:"2.8.2"},100686922:{apkId:0,appFeature:0,appType:4,appType_sub:9023,appid_haina:5613,id:100686922,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:8,mark_nums:1108,mark_nums_all:2089,migid:0,name:"腾讯新闻",orientation:0,pName:"com.tencent.news",playCount:0,prelen:3,quickbar:0,secCate:"",shortDes:"新闻类应用中的标杆！重大事件瞬间推送，支持媒体订阅，收藏和分享。",size:"4.5M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:5,url:"http://down.myapp.com/android_new/312/595312/16722219/com.tencent.news_321.apk",userCount:11994721,versionCode:321,versionName:"3.2.1"},100686925:{apkId:0,appFeature:4406,appType:4,appType_sub:4019,appid_haina:0,id:100686925,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:7,migid:4406,name:"微云",orientation:0,pName:"com.qq.qcloud",playCount:0,prelen:3,quickbar:0,secCate:"工具",shortDes:"微云是腾讯公司为用户精心打造的一项智能云服务, 您可以通过微云方便地在手机和电脑之间,同步文件、推送照片和传输数据。",size:"8.4M",sourcetype:0,status:5,supportversion:"",tyqtype:4,url:"http://dldir1.qq.com/weiyun/weiyun_android_1.6.338.56.apk",userCount:105808,versionCode:302,versionName:"1.5.0"},100686929:{apkId:0,appFeature:0,appType:4,appType_sub:4019,appid_haina:226189,id:100686929,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:7,mark_nums:711,mark_nums_all:1487,migid:0,name:"QQ提醒",orientation:0,pName:"com.tencent.qqcalendar",playCount:0,prelen:3,quickbar:0,secCate:"工具",shortDes:"叫您起床，提醒您QQ好友的生日，领取游戏大礼包等，有了TA，生活更舒心。",size:"5.6M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:5,url:"http://down.myapp.com/android_new/872/575872/16680079/com.tencent.qqcalendar_13.apk",userCount:2369755,versionCode:13,versionName:"2.3.1"},100686931:{apkId:0,appFeature:0,appType:4,appType_sub:5011,appid_haina:184954,id:100686931,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:8,mark_nums:3767,mark_nums_all:6301,migid:0,name:"魅拍",orientation:0,pName:"com.tencent.qqcamera",playCount:0,prelen:3,quickbar:0,secCate:"拍照",shortDes:"对那些成天45度角，卖萌耍宝的自拍妹子，我真想说：拍拍拍，拍你“魅”啊。",size:"16.3M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:5,url:"http://down.myapp.com/android_new/534/130534/16792996/com.tencent.qqcamera_61.apk",userCount:6913543,versionCode:61,versionName:"3.1.5"},100686935:{apkId:0,appFeature:4411,appType:4,appType_sub:9004,appid_haina:0,id:100686935,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:7,migid:4411,name:"爱讲冷笑话",orientation:0,pName:"com.coldworks.coldjoke",playCount:0,prelen:3,quickbar:0,secCate:"娱乐",shortDes:"我们爱讲冷笑话，每日一冷，快乐每一天。冷笑话聚集地，这里有最冷最新潮的笑话的，还有更多爆笑图片奇闻趣事。",size:"1.3M",sourcetype:0,status:5,supportversion:"",tyqtype:4,url:"http://softfile.3g.qq.com/msoft/sqapp/coldjoke_yingyongbao_0104.apk",userCount:259763,versionCode:0,versionName:"1.2.2"},100686944:{apkId:0,appFeature:0,appType:4,appType_sub:4018,appid_haina:10237,id:100686944,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:8,mark_nums:2935,mark_nums_all:5367,migid:0,name:"SOSO街景地图",orientation:0,pName:"com.tencent.map",playCount:0,prelen:3,quickbar:0,secCate:"导航",shortDes:"微流量地图随心看。现在还有快捷叫车，美食酒店等生活优惠，不仅只是地图哦！",size:"10.9M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:5,url:"http://down.myapp.com/android/42277/16676906/com.tencent.map_203.apk",userCount:4848270,versionCode:203,versionName:"3.2"},801008384:{apkId:0,appFeature:0,appType:4,appType_sub:9004,appid_haina:5640,id:801008384,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:7,mark_nums:74,mark_nums_all:153,migid:0,name:"冷笑话精选",orientation:0,pName:"com.feibo.joke",playCount:0,prelen:3,quickbar:0,secCate:"娱乐",shortDes:"这年头，提升一个人的魅力指数，幽默是很重要的，而这款用软件会帮助你变得更幽默。",size:"3.1M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:5,url:"http://down.myapp.com/android_new/10/91010/16757380/com.feibo.joke_32.apk",userCount:284162,versionCode:32,versionName:"3.4"},801097412:{apkId:0,appFeature:0,appType:4,appType_sub:4019,appid_haina:11384,id:801097412,isGenIcon:0,isHot:0,ismultipf:0,mGame:0,mark:9,mark_nums:236502,mark_nums_all:333496,migid:0,name:"QQ浏览器",orientation:0,pName:"com.tencent.mtt",playCount:0,prelen:3,quickbar:0,secCate:"工具",shortDes:"超快的浏览器!同时还拥有清新的界面，操作也很简单，还支持阅读器和视频播放。",size:"10.4M",sourcetype:0,status:2,supportversion:"2.2+",tyqtype:5,url:"http://down.myapp.com/android/49367/16840718/com.tencent.mtt_450520.apk",userCount:86747960,versionCode:450520,versionName:"4.5.2.540"}},category:{home:[100682801,100682088,100645222,100680010,100621162,801008384,100422914,100686843,100686853,100686925,100686922,100686842,801097412,100686935,100631344,100686931],hotnogame:[100682801,100682088,100680010,100422914,100621162,801008384,100686922,100686842,801097412,100686843,100686853,100686925,100686935,100631344,100686931,100686929,100686851,100686944,100686920,100686850],guess:[100682801,100682088,100680010,100686931,100621162,100686925]}});define("Const",function(){var a=require("LocalStorage"),b=window.agentData||{},c={appid:"100",Currentversion:b.currentVersion||a.get("currentVersion"),Platform:b.platform||a.get("platform"),Uin:b.uin,url_prex:"http://app.z.qq.com/",channelId:1e3,app_custom:"",AgentVersion:b.agentVersion||a.get("agentVersion"),MobileInfo:require("$").parseJSON(b.mobileInfo||a.get("mobileInfo")),Display:b.display||a.get("display"),pageParams:b.pageParams,imgRoot:b.imgRoot||a.get("imgRoot"),enableWebDatabase:Date.now()-parseInt(a.get("disableWebDatabaseTime"))>6048e5?true:a.get("enableWebDatabase")==="false"?false:true,debug:false};return c});define("LocalAppFileds",{pName:0,versionCode:1,versionName:2,name:3});define("QzoneApp",{Api:{},Mod:{}});define("JsBridge",function(){var a={callback:function(){require("Event").fire.apply(require("Event"),arguments)}};return a});define("Config",{app:"qzone_app",db:"qzone_db",http:"qzone_http",image:"qzone_imageCache",worker:"q_worker",download:"q_download",client:"qqZoneAppList",qqApi:"QQApi"});define("Bridge",function(){var b=require("LocalStorage"),a={compatible:parseInt(require("LocalStorage").get("bridge_compatible"))||3,reduce:function(){this.compatible>1&&this.compatible--;b.set("bridge_compatible",this.compatible);b.set("bridge_compatible_time",Date.now())},createIframe:function(){var c=document.createElement("iframe");c.style.cssText="display:none;width:0px;height:0px;";document.body.appendChild(c);return c},removeIframe:function(d){var c=document.querySelector("iframe_jsBridge_"+d);c&&(c.src="about:blank",document.body.removeChild(c))},send:function(g,h,i,j){var d=j||{},c="jsbridge://"+[encodeURIComponent(g),encodeURIComponent(h),d.guid||0].join("/");i.forEach(function(e){c+="/"+encodeURIComponent(String(e))});var f=function(){var e=a.createIframe();e.id="iframe_jsBridge_"+d.guid;e.src=c};try{switch(a.compatible){case 3:console.log(c);break;case 2:alert(c);break;case 1:f();break;default:require("M").stringReport({errMsg:"JSBridge do not support this compatible mode : "+a.compatible,code:-460,duration:0})}}catch(k){this.compatible=0;f()}}};a.compatible!=3&&Date.now()-parseInt(b.get("bridge_compatible_time"))>6048e5&&(a.compatible=3);return a});define("Notify",function(a,c){var j=a("Collector"),g=5e3,d=new j(500,10),e={},f=[],b=[],h=true,i=function(){var k=a("Bridge"),l=f.splice(0);k.compatible>1?(k.reduce(),l.forEach(function(m){var n=m&&m[3];n.guid&&(b[n.guid]&&clearTimeout(b[n.guid]),n.timeout&&(b[n.guid]=setTimeout(i,g)),f.push(m),d.push({ns:m[0],method:m[1],guid:n.guid,args:m[2]}))})):a("M").stringReport({errMsg:"JSBridge do not support iframe compatible mode : "+k.compatible,code:-460,duration:0})};c.combineRequest=true;c.pull=function(m,l,k,n){return a("Task").create(function(){var r=this,q=a("Type"),p=n||{};!p.guid&&(p.guid=function(){var o=a("AsyncInterface").add(l,function(t){var s=a("Bridge");if(b[o]){clearTimeout(b[o]);var u=90+s.compatible;a("ValueStat").report("350716",1,u,{reportRate:s.compatible==3?10:1})}r.parentResolve(t.data);delete e[o];delete b[o];s.compatible==0&&s.removeIframe(o)});return o}());k&&(q.isObject(k)&&(k=a("$").stringify(k)),!q.isArray(k)&&(k=[].concat(k)));e[p.guid]=Date.now();h&&(p.timeout=true,h=false);p.timeout&&(b[p.guid]=setTimeout(i,g));f.push([m,l,k||[],p]);!p.immediately&&c.combineRequest?d.push({ns:m,method:l,guid:p.guid,args:k||[]}):a("Bridge").send(m,l,k||[],p);this.async=true})};c.sendBatch=function(k){a("Bridge").send(a("Config").client,"callBatch",[a("$").stringify(k),"500","10"],{guid:a("AsyncInterface").up()})};c.getDuration=function(k){return e[k]||0};d.on("fulled",c.sendBatch)});define("BatchCallback",function(){var a={init:function(){require("Event").on("batchCallback",function(b){b.r==0?require("Type").isArray(b.data)&&require("Util").each(b.data,function(c){QzoneApp.fire.apply(QzoneApp.fire,c)}):require("M").stringReport({errMsg:"BatchCallback error msg : "+b.data,code:-560,duration:0})})}};a.init();return a});define("Api",function(){var a=require("Const"),b=require("Config").client,c={get:function(d,e){if(!a[d]||e){return require("Task").create(require("Notify").pull(b,"get"+d)).then(function(f){a[d]=f;d=="Uin"&&require("LocalStorage").set("uin",f);return f})}else{return a[d]}},getUrlParam:function(d,e,i){var f=require("Util"),g=a.pageParams,h=f.getUrlParam(d,e,i||g);if(!h&&!g){return require("Task").create(require("Notify").pull(b,"getParams")).then(function(j){a.pageParams=j;return f.getUrlParam(d,e,j)})}return h},getMobileInfo:function(d){return !d&&a.MobileInfo?a.MobileInfo:require("Task").create(this.get("MobileInfo",true)).then(function(e){a.MobileInfo=require("$").parseJSON(e);return a.MobileInfo})},openLocalUrl:function(d){d.url="sd://"+d.url;c.openUrl(d)},openUrl:function(e){var d=e;if(""==d.url){return}d.current=d.current||0;d.titleInfo=d.titleInfo?[].concat(d.titleInfo):[];require("Notify").pull(b,"goUrl",d,{immediately:true}).start()},showMsg:function(d){require("Notify").pull(b,"showToast",[String(d)]).start()},setUrlParam:function(d,e){d!==""&&require("Task").create(c.getUrlParam(d)).then(function(g){e=encodeURIComponent(e);var f=a.pageParams;g?f=f.replace(new RegExp("([?#&]"+d+"=)([^#&]*)","i"),"$1"+e):f+="&"+d+"="+e;a.pageParams=f;require("Notify").pull(b,"setParams",[f]).start()}).start()},setAllowCallBackEvent:function(d){require("Notify").pull(b,"setAllowCallBackEvent",[d?1:0],{immediately:true}).start()},goToDetailPage:function(d){var e={url:d.url,appid:d.appid,apkId:d.apkId,myAppId:d.myAppId,packageName:d.pName,via:d.via,versionCode:d.versionCode,isAutoDownload:d.isAutoDownload,isAutoInstall:d.isAutoInstall};e=require("$").stringify(e);require("Notify").pull(b,"goToDetailPage",[e,""+(d.toMyApp||1)],{immediately:true}).start()},clearCache:function(){require("Notify").pull(require("Config").http,"clearWebViewCache").start()},getMinClientWidth:function(){return require("Task").create(require("Api").get("Display")).then(function(d){var e=require("Const");if(!e.minClientWidth){var d=d.split("x");e.minClientWidth=Math.min(d[0],d[1])/(d[0]/document.body.clientWidth)}return e.minClientWidth})}};return c});define("App",function(){var b=require("Config").app,a={name:require("TableConfig").app.name,name_userInfo:require("TableConfig").user_info.name,idCache:{},pNameCache:{},dfData:require("DfData")||{},add:function(c){var d=require("Util"),e=this,c=[].concat(c),f=[],h=[],g=[];d.each(c,function(i){g.push(i.id)});require("Task").create().map({uin:require("Api").get("Uin"),localRet:a.getAppsByIds(g,true)}).then(function(k){var j=require("$"),i=require("Database"),l=k.uin,m=k.localRet,n=!!m.length;n&&(c.forEach(function(o){var p=a.idCache[o.id];p?(d.each(o,function(q,r){q&&(p[r]=q)}),f.push(p)):f.push(o)}),c=f);i.multiUpdate({into:e.name_userInfo,fields:"id, info, friends, feeds, code",values:c},function(p){var o=[],q={};q.playCount=p.playCount;o.push(p.id);o.push(i._escSql(j.stringify(q)));o.push(i._escSql(j.stringify(p.friends||{})));o.push(i._escSql(j.stringify(p.feeds||"")));o.push(l);return o});return i.multiUpdate({into:e.name,fields:"id,v,imid,pName,ext",values:c},function(q){var p=[],o={};o=d.extend(o,q);o.feeds&&delete o.feeds;o.friends&&delete o.friends;o.playCount&&delete o.playCount;p.push(o.id);p.push(i._escSql(j.stringify(o)));p.push(o.migid||0);p.push(o.pName||"");p.push(i._escSql(j.stringify({des:o.des||"",newFeature:o.newFeature||""})));e._saveCache(q);return p})}).start()},_saveCache:function(c){this.idCache[c.id]=c;this.pNameCache[c.pName]=c},__parseApp:function(c,k){var e=require("$"),f=require("Util");if(!require("Const").enableWebDatabase){var d=e.parseJSON(c[0])||k,g=c[1]&&e.parseJSON(c[1])||null,h=c[2]&&e.parseJSON(c[2])||null,i=c[3]&&e.parseJSON(c[3])||null,j=c[4]&&e.parseJSON(c[4])||null}else{var d=e.parseJSON(c.v)||k,g=e.parseJSON(c.ext)||null,h=e.parseJSON(c.uInfo)||null,i=e.parseJSON(c.uFriends)||null,j=e.parseJSON(c.feeds)||null}if(d.id){g&&(d=f.extend(d,g));h&&(d=f.extend(d,h));i&&(d=f.extend(d,{friends:i}));j&&(d=f.extend(d,{feeds:j}));return d}return null},getAppById:function(c,d){return require("Task").create(this.getAppsByIds(c,d)).then(function(e){return e&&e[0]||null})},getAppByPName:function(c,d){if(this.pNameCache[c]){return this.pNameCache[c]}return require("Task").create(require("Api").get("Uin")).then(function(e){return require("Database").select({select:"a.v, a.ext, u.info, u.friends, u.feeds",from:a.name+" a , "+a.name_userInfo+" u",where:'a.pName = "'+c+'" and u.id = a.id and u.code = '+e})}).then(function(e){var g=d?null:a.dfData.pName&&a.dfData.pName[c];if(!require("Const").enableWebDatabase){e=require("$").parseJSON(e);if(e.length){var f=a.__parseApp(e[0],g);f&&a._saveCache(f)}}else{if(e.length&&e[0].length){var f=a.__parseApp(e[0].item(0),g);f&&a._saveCache(f)}}return f||g||null})},getAppsByIds:function(d,k){var e=require("Util"),c=this,f=[],g=[],h=c.idCache;d=[].concat(d);var i=a.dfData.app||{},j=function(){e.each(d,function(l){h[l]?g.push(h[l]):!k&&i[l]&&g.push(i[l])});return g};e.each(d,function(l){!h[l]&&f.push(l)});if(f.length>0){return require("Task").create(require("Api").get("Uin")).then(function(l){return require("Database").select({select:"a.v, a.ext, u.info, u.friends, u.feeds",from:a.name+" a , "+a.name_userInfo+" u",where:"a.id in ("+f.join(",")+") and u.id = a.id and  u.code = "+l})}).then(function(l){if(!require("Const").enableWebDatabase){l=require("$").parseJSON(l);e.each(l,function(q){try{var p=c.__parseApp(q);p&&c._saveCache(p)}catch(r){}})}else{resultSet=l.length&&l[0]||[];for(var m=0,o=resultSet.length;m<o;m++){item=resultSet.item(m);var n=c.__parseApp(item);n&&c._saveCache(n)}}return j()})}return j()},getAppsByCate:function(c,d,e,f){return require("Task").create(require("Category").getCategory(c,d,e)).then(function(g){return g.length>0?a.getAppsByIds(g,f):[]}).then(function(g){return g})},getInstalledApp:function(){return require("Task").create(require("Notify").pull(b,"getAllDownAppInfo",[false,false,false])).then(function(c){return c?require("$").parseJSON(c):[]})},getAppInfo:function(c){if(require("Type").isArray(c)){return require("Task").create(require("Notify").pull(b,"getAppInfoBatch",[c.join(","),",",false,false,false])).then(function(d){return d&&require("$").parseJSON(d)||[]})}else{return require("Task").create(require("Notify").pull(b,"getAppInfo",[c,false,false,false])).then(function(d){return d&&require("$").parseJSON(d)||[]})}},isInstall:function(c){if(require("Type").isArray(c)){return require("Task").create(require("Notify").pull(require("Config").client,"appIsExistsBatch",[c.join(","),","])).then(function(d){return String(d)||""})}else{return require("Task").create(require("Notify").pull(require("Config").client,"appIsExists",[c])).then(function(d){return String(d)=="true"?true:false})}},unInstallApp:function(d,c){c&&(require("Storage").setMemValue(c,d+""),require("Notify").pull(b,"uninstallApp",[c]).start())},startApp:function(n){var c=n||{};c.tyqtype+="";c.appid+="";var f=require("Channel"),i=require("Via"),h=require("Const"),j,g,l,k,e=c.channelId,d=function(){require("Update").userAddApp(c.appid);require("Category").changeRecentPlay(c.appid)},m=function(){var o=require("Notify"),p=require("Config").client;switch(c.tyqtype){case"0":o.pull(p,"startApp",[c.pName,c.appurl],{immediately:true}).start();d();break;case"1":o.pull(p,"startOpenApp",[c.pName,c.appurl,c.appid,"",c.appCustom||h.app_custom],{immediately:true}).start();d();break;case"2":o.pull(p,"startAppWithData",[c.pName,c.appurl],{immediately:true}).start();d();break;case"3":o.pull(p,"startOpenApp",[c.pName,c.appurl,c.appid,"",c.appCustom||h.app_custom],{immediately:true}).start();d();break;case"4":o.pull(p,"startApp",[c.pName,c.appurl],{immediately:true}).start();d();break;case"5":o.pull(p,"startOpenApp",[c.pName,c.appurl,c.appid,"",c.appCustom||h.app_custom],{immediately:true}).start();d();break;case"6":o.pull(p,"startApp",[c.pName,c.appurl],{immediately:true}).start();d();break;case"7":o.pull(p,"startOpenApp",[c.pName,c.appurl,c.appid,"",c.appCustom||h.app_custom],{immediately:true}).start();d();break;case"8":o.pull(p,"startApp",[c.pName,c.appurl],{immediately:true}).start();d();break;default:o.pull(p,"startApp",[c.pName,c.appurl],{immediately:true}).start();break}};require("Task").create().map({app:a.getAppById(c.appid),via:i.getPageVia(e==f.HOMESOCIAL||e==f.HOMEREC||e==f.SEARCHRESULT||e==f.BOUTIQUE?e:""),channelVia:i.getChannelVia(e)}).then(function(o){j=o.app,g=o.via,l=o.channelVia;g=e==f.HOMESOCIAL?g+"."+c.rank:g;k=(f.DETAIL==require("Const").channelId?l:g)+i.getSourceVia(c.appid,e);c.pName&&(j.ieg_ticket?(require("Notify").pull(require("Config").qqApi,"launchAppWithTokens",[c.appid,j.ieg_ticket,c.pName,"0"]).then(function(){},function(p){p.r==1&&m()}).start(),d()):m());!c.isAutoStart?require("Stat").startApp(k,c.appid):require("Stat").autoStartApp(k,c.appid)}).start()},goWebApp:function(i){var d=i||{};d.tyqtype+="";var f=require("Channel"),g=require("Via"),j,k,l,h,e=d.channelId,c=d.appid+="";d.appurl?require("Task").create().map({app:a.getAppById(c),via:g.getPageVia(e==f.HOMESOCIAL||e==f.HOMEREC||e==f.SEARCHRESULT||e==f.BOUTIQUE?e:""),channelVia:g.getChannelVia(e)}).then(function(p){var m=p.app,n=p.via,r=p.channelVia,o=m.sourcetype==2,q=o?1==m.quickbar?1:0:1;n=e==f.HOMESOCIAL?n+"."+d.rank:n;h=(f.DETAIL==require("Const").channelId?r:n)+g.getSourceVia(c,e);!d.isAutoStart?require("Stat").startApp(h,c):require("Stat").autoStartApp(h,c);require("Update").userAddApp(c);require("Category").changeRecentPlay(c);require("Notify").pull(require("Config").client,"goWebApp",{appid:c,webviewConfig:o?m.webviewConfig||255:-1,args:d.webargs||"",strUrl:d.appurl,type:o?1:0,showQuickBar:q,screenOrientation:m.orientation||0,fullScreen:q?0:1,showDialog:o?1==m.isGenIcon?1:0:0,appName:m.name,appIconUrl:require("ImgCache").getImgUrl("logo",c,c+"_100_m.png")},{immediately:true}).start()}).start():require("Api").showMsg("应用地址为空，启动应用失败")},getRecentApp:function(){var c=require("LocalStorage").get("latest_num")||5;return require("Notify").pull(b,"getRecentApp",[c])},getAppVersionCode:function(c,d,e){return require("Task").create(require("Notify").pull(require("Config").client,"getAppVersionCode",{packageName:d,appid:c,downloadUrl:e})).then(function(f){f&&(f=require("$").parseJSON(f.replace(/\s+/g,"")));return f})},getAppVersionCodeBatch:function(c){if(require("Type").isArray(c)&&c.length){var d=require("$");return require("Task").create(require("Notify").pull(require("Config").client,"getAppVersionCodeBatch",d.stringify(c))).then(function(e){return e&&d.parseJSON(e)})}else{return[]}}};return a});define("AppUpdateData",function(){var a={data:{},map:{},check:function(b){b=[].concat(b);b.length&&require("Task").create(require("Notify").pull(require("Config").download,"checkUpdate",{packageNames:b})).then(function(c){c=require("$").parseJSON(c);a.data=c;require("Util").each(c,function(d){d.packageName&&(a.map[d.packageName]=d)})}).start()},getByPName:function(b){return a.map[b]||""}};return a});define("AsyncInterface",function(){var d=require("Events").eventEmitter,a=new d(),b=0,c=location.pathname.slice(location.pathname.lastIndexOf("/")+1)+"_",e={evt:a,add:function(f,g){++b;a.on(c+f+"_"+b,g);return b},emit:function(f,g,h){a.emit.call(a,c+f+"_"+g,h)},up:function(){return++b}};return e});define("Collector",function(){var b=require("Events").eventEmitter,a=function(c,d){this.time=c||1e3;this.count=d||10;this.timer=null;this.pool=[];this.evt=new b()};a.prototype={push:function(c){var d=this;this.pool.push(c);!this.timer&&(this.timer=setTimeout(function(){d.fulled()},this.time));this.pool.length>this.count&&this.fulled()},fulled:function(){this.timer&&(this.timer=clearTimeout(this.timer));this.evt.emit("fulled",this.pool.splice(0))},on:function(){this.evt.on.apply(this.evt,arguments)}};return a});define("Category",function(){var a={name:require("TableConfig").category.name,id:{home:"home_",hotnogame:"hotnogame_",latest_used_app:"latest_used_app",myapplist_v2:"myapplist_v2_",myapp_pc:"myapp_pc_",updateapp:"updateapp_",notify:"notify_",def_home:"def_home",def_hotnogame:"def_hotnogame",def_guess:"def_guess"},cate:{},cateNext:null,getCategory:function(c,f,d){var b;d=d||require("Update").pageSize;var e=function(){b=[].concat(b);if(f){var h=Math.max(0,f-1)*d,i=Math.min(b.length,h+d);return b.slice(h,i)}else{return b}};if(/^def_/.test(c)){var g=require("DfData").category||{};b=g[c.replace(/^def_/,"")];return e()}else{return require("Task").create(require("Api").get("Uin")).then(function(i){var j=this;c+=i;b=a.cate[c];if(!b){var h=require("LocalStorage");if(h.support){b=require("$").parseJSON(h.get(c))||[];return e()}else{return require("Task").create(require("Database").select({select:"v",from:a.name,where:{id:c}})).then(function(k){var l=require("$");!require("Const").enableWebDatabase?(k=l.parseJSON(k),b=k&&k.length>0?l.parseJSON(k[0][0]):[]):b=k&&k.length&&k[0].length>0?k[0].item(0).v:"";a.cate[c]=b;return e()})}}else{return e()}})}},getCateNext:function(b,c){c+="";if(!this.cateNext){return require("Task").create().map({uin:require("Api").get("Uin"),cateNext:require("Storage").getItem("cateNext")}).then(function(d){b+=d.uin;a.cateNext=require("$").parseJSON(d.cateNext)||{};!a.cateNext[b]&&(a.cateNext[b]={});return a.cateNext[b][c]||false})}else{return require("Task").create(require("Api").get("Uin")).then(function(d){b+=d;!a.cateNext[b]&&(a.cateNext[b]={});return a.cateNext[b][c]||false})}},setCateNext:function(b,c,d){c+="";require("Task").create(require("Api").get("Uin")).then(function(e){b+=e;!a.cateNext[b]&&(a.cateNext[b]={});a.cateNext[b][c]=d;require("Storage").setItem("cateNext",require("$").stringify(a.cateNext))}).start()},addIntoCategory:function(b,c,d){require("Task").create(this.getCategory(b)).then(function(e){e&&(e=require("Util").addToArray(e,c,d),a.setCategory(b,e))}).start()},removeFromCategory:function(b,c){require("Task").create(this.getCategory(b)).then(function(d){d.length&&(d=require("Util").removeFromArray(d,c),a.setCategory(b,d))}).start()},setCategory:function(b,c){c&&require("Task").create(require("Api").get("Uin")).then(function(e){b+=e;a.cate[b]=c;var d=require("LocalStorage");d.support?d.set(b,require("$").stringify(c)):require("Database").update({into:a.name,values:{id:b,v:require("$").stringify(c)}})}).start()},changeRecentPlay:function(b){require("Task").create().map({cate:this.getCategory(this.id.latest_used_app),pcapps:this.getCategory(this.id.myapp_pc)}).then(function(d){b=parseInt(b);var c=d.cate,e=d.pcapps;c=require("Util").removeFromArray(c,b);c.splice(e.length,0,b);a.setCategory(a.id.latest_used_app,c)}).start()}};return a});define("Database",function(){var b=require("Config").db,a={tables:{},tmpl:{},verifyTable:function(){require("Notify").pull(b,"verifyTable",require("TableConfig"),{timeout:true}).start()},select:function(d){var c=this.tmpl.select({data:d,rep:this._escSql});if(!require("Const").enableWebDatabase){return require("Notify").pull(b,"select",[c])}else{return require("WebDataBase").select(c)}},del:function(d){var c=this.tmpl.del({data:d,rep:this._escSql});!require("Const").enableWebDatabase?require("Notify").pull(b,"exec",[c]).start():require("WebDataBase").exec(c)},update:function(d){var c=this.tmpl.update({data:d,rep:this._escSql});!require("Const").enableWebDatabase?require("Notify").pull(b,"exec",[c]).start():require("WebDataBase").exec(c)},multiUpdate:function(d,e){var c=this.tmpl.mutliUpdate({data:d,callBack:e,rep:this._escSql});!require("Const").enableWebDatabase?require("Notify").pull(b,"exec",[c]).start():require("WebDataBase").exec(c)},_escSql:function(c){c=c+"";return c.replace(/'/g,"''")}};a.tmpl.create=function(d){with(d||{}){var c=[];c.push("create table ");c.push(tName);c.push(fields);c.push(";");return c.join("")}};a.tmpl.drop=function(d){with(d||{}){var c=[];c.push("drop table if exists ");c.push(tName);c.push(";");return c.join("")}};a.tmpl.select=function(g){with(g||{}){var c=[];c.push("select ");c.push(data.select);c.push(" from ");c.push(data.from);var d=data.where,e=[];if(d){c.push(" where ");if(typeof d=="string"){c.push(d)}else{for(var f in d){one=d[f];one&&(one.op?e.push(f+" "+one.op+" '"+rep(one.value)+"'"):e.push(f+"='"+rep(one)+"'"))}c.push(e.join(" and "))}}c.push(";");return c.join("")}};a.tmpl.del=function(f){with(f||{}){var c=[];c.push("delete from ");c.push(data.from);if(data.where){var d=[];if(typeof where=="string"){c.push(where)}else{c.push(" where ");for(var e in data.where){d.push(e+"='"+rep(data.where[e])+"'")}c.push(d.join(" and "))}}c.push(";");return c.join("")}};a.tmpl.update=function(g){with(g||{}){var c=[];c.push("replace into ");c.push(data.into);var d=[],e=[];for(var f in data.values){d.push(f);e.push("'"+rep(data.values[f])+"'")}c.push("(");c.push(d.join(","));c.push(")values(");c.push(e.join(","));c.push(");");return c.join("")}};a.tmpl.mutliUpdate=function(j){with(j||{}){var c=[];c.push("replace into ");c.push(data.into);c.push("(");c.push(data.fields);c.push(") ");var g=[];for(var h in data.values){if(!data.values[h]){continue}var e=callBack(data.values[h]);for(var f=0;f<e.length;f++){e[f]="'"+rep(e[f])+"'"}g.push("select "+e.join(","))}c.push(g.join(" union all "));return c.join("")}};!require("Const").enableWebDatabase&&a.verifyTable();return a});define("WebDataBase",function(){var a={DBNAME:"QzoneAppCenter",VERSION:"1.0",SIZE:8,db:null,SQL_SYS_TABLE:{create:"create table if not exists sys_table (table_name VARCHAR(50) PRIMARY KEY,version INTEGER);",select:"select * from sys_table;"},tables:{},isInit:false,isVerifyTable:false,init:function(){var b=[this.SQL_SYS_TABLE.create,this.SQL_SYS_TABLE.select];return a.isInit?true:require("Task").create(this._transaction(b)).then(function(d){var e=d&&d[1]||[],f=e.length;if(f){for(var c=0;c<f;c++){var g=e.item(c);a.tables[g.table_name]=g.version}}return a.isInit=true})},open:function(){var b=1,c=Date.now();try{this.db=openDatabase(this.DBNAME,this.VERSION,this.DBNAME,this.SIZE*1024*1024)}catch(d){require("LocalStorage").set("disableWebDatabaseTime",Date.now());require("LocalStorage").set("dataUpdateTime","");b=2;require("M").stringReport({errMsg:d.message,code:-550,duration:0})}require("Const").enableWebDatabase=b==1?true:false;require("LocalStorage").set("enableWebDatabase",b==1?true:false);var f=90+b;require("ValueStat").report("350735",1,f,{duration:Date.now()-c,reportRate:b==1?10:1})},_transaction:function(b){return require("Task").create(function(){!a.db&&a.open();b=[].concat(b);var c=b.length;if(a.db&&c){var d=this;this.async=true;a.db.transaction(function(g){var h=false,e=0,f=[];b.forEach(function(i){g.executeSql(i,[],function(k,j){e++;f.push(j.rows);e==c&&d.parentResolve(f)},function(k,j){h=true;d.parentReject(j.message)})})})}})},select:function(b){return require("Task").create(this.verifyTable()).then(function(){return a._transaction(b)})},exec:function(b){require("Task").create(this.verifyTable()).then(function(){return a._transaction(b)}).start()},verifyTable:function(){return this.isVerifyTable?true:require("Task").create(this.init()).then(function(){var b=[],c=a.tables,d=require("TableConfig");require("Util").each(d,function(e){var f=c[e.name]||0;f!=e.version&&(b.push(a.tmpl.drop({tName:e.name})),b.push(e.sql),b.push(a.tmpl.update({tName:e.name,version:e.version})))});return a._transaction(b).then(function(){a.isVerifyTable=true})})}};a.tmpl={};a.tmpl.update=function(c){with(c||{}){var b=[];b.push("replace into 'sys_table'('table_name', 'version') values('");b.push(tName);b.push("', '");b.push(version);b.push("');");return b.join("")}};a.tmpl.drop=function(c){with(c||{}){var b=[];b.push("drop table if exists '");b.push(tName);b.push("';");return b.join("")}};return a});define("DfData",function(){var b=require("Util"),a=require("DefaultData");a&&a.app&&(a.pName={},b.each(a.category,function(d,c){a[c]=[];b.each(d,function(f){var e=a.app[f];e&&(a[c].push(e),e.pName&&(a.pName[e.pName]=e))})}));return a});define("Download",function(){var b=require("Config").download,c=require("Events").eventEmitter,d=1101070898,a={STATE:{ALL:0,INIT:1,DOWN:2,PAUSE:3,DOWN_END:4,SETUP:5,SETUP_END:6,SETUP_END_UPDATEPROSTATE:100,UNINSTALL_END:9,CANCEL:10,UPDATE:12,PACKAGE_REPLACE:13,WAIT:20,ERROR_SYSTEM:-1,ERROR_DOWN_EXCEPTION:-2,ERROR_SD_UNMOUNT:-3,ERROR_URL_CHANGE:-4,ERROR_NET_ERROR:-5,ERROR_SD_NOSPACE:-6},PSTATE:{DEFAULT:0,INSTALL:1,UNINSTALL:2},evt:new c(),downData:{},_proCache:{},init:function(){require("Event").on("loadProcess",function(){a.nativeCallback.apply(a,arguments)});this.addListener(this.STATE.UNINSTALL_END,function(e){e.appid&&a.updateProState(e.appid,a.PSTATE.UNINSTALL)});this.addListener(this.STATE.SETUP_END_UPDATEPROSTATE,function(f){var e=f.appid;e&&(a.updateProState(e,a.PSTATE.INSTALL),require("Task").create(require("App").getAppById(e)).then(function(g){g&&/^[23456]$/.test(g.tyqtype)&&(require("Update").userAddApp(e,undefined,"install"),require("Category").changeRecentPlay(e))}).start())})},addListener:function(e,f){this.evt.on(e,f)},notify:function(f,g,h){var e=h||{};this.evt.emit(f,e.overwrite||this.downData[g],e.isQuery)},nativeCallback:function(f){var g=this;try{if(require("Type").isArray(f)){require("Util").each(f,function(e){g.nativeCallback(e)})}else{var i=f.appid,h=f.packagename;h&&!i?require("Task").create(require("Storage").getMemValue(h)).then(function(e){var k=function(){e&&f.state&&g.downCallback({appid:e,pro:0,state:f.state,phony_pro:0})};!e?require("Task").create(require("App").getAppByPName(h)).then(function(l){l&&(e=l.id)&&k()}).start():k()}).start():g.downCallback(f)}}catch(j){}},downCallback:function(e,f){this.downData[e.appid]=e;this.notify(e.state,e.appid,{isQuery:f});this.notify(this.STATE.ALL,e.appid,{isQuery:f});this.STATE.SETUP_END==e.state&&this.notify(this.STATE.SETUP_END_UPDATEPROSTATE,e.appid,{isQuery:f})},getProState:function(e){return this._proCache[e]||0},updateProState:function(e,f,g){var h=this._proCache[e]||0;this.PSTATE.UNINSTALL==f&&!g&&require("Task").create(this.query(e,{needRet:true})).then(function(i){i&&!i[0]&&h==1&&a.notify(a.STATE.UNINSTALL_END,e,{overwrite:{appid:e,pro:0,state:a.STATE.UNINSTALL_END,phony_pro:0}})}).start();this._proCache[e]=f},query:function(e,g){var h=this,i=g||{},e=[].concat(e);if(e.length){var f=require("Task").create(require("App").getAppsByIds(e)).then(function(k){var j=[];require("Util").each(k,function(l){j.push({appid:l.id,myAppId:l.appid_haina||l.myAppId||"",apkId:l.apkId||"",packageName:l.pName,versionCode:l.versionCode})});return require("Notify").pull(b,"getQueryDownloadAction",[require("$").stringify(j)])}).then(function(j){require("Util").each(j,function(k){h.downCallback(k,true)});return j});return i.needRet?f:f.start()}else{return[]}},cancelNotification:function(e,f){e&&require("Notify").pull(b,"cancelNotification",["_"+e]).start();f&&require("Notify").pull(b,"cancelNotification",[""+f]).start()},cancel:function(e){require("Notify").pull(b,"cancelDownload",[""+e,"_"+e]).start()},go:function(x){var p=require("Const"),l=require("App"),j=require("Via"),i=require("Channel"),f=this.STATE,q=null,r=null,k=null,s=null,t=null,u=null,e=x||{},g=e.channelId,v=e.overWriteState||"",y=e.pcpush?"1":"0",h=this.downData[e.appid]||"",m="",n=function(o){o!=f.SETUP&&(h.state=o);var z={myAppConfig:e.pName=="com.tencent.android.qqdownloader"?0:e.myAppConfig,appid:e.appid+"",url:e.appurl,packageName:e.pName,actionCode:o,via:u?msgVia:t?r:q,appName:k.name,notifyKey:"N_"+e.appid,updateData:require("AppUpdateData").getByPName(e.pName)||"",updateType:0,myAppId:parseInt(e.myAppId,10)==0?"":e.myAppId,apkId:parseInt(e.apkId,10)==0?"":e.apkId,versionCode:e.versionCode,isAutoDownload:"1",isAutoInstall:"1",toPageType:e.toPageType,showNetworkDialog:y,wording:e.wording||""};require("Notify").pull(b,"doDownloadAction",z,{immediately:true}).start()},w=function(){!h&&(h={appid:e.appid,pro:0,state:f.INIT,phony_pro:0},a.downData[e.appid]=h);h.state=Math.max(1,h.state);v&&(h.state=v);switch(h.state){case f.INIT:m=e.isUpdate?f.UPDATE:f.DOWN;a.notify(f.INIT,e.appid);case f.PAUSE:case f.UPDATE:case f.UNINSTALL_END:case f.WAIT:case f.CANCEL:n(m||f.DOWN);a.notify(m||f.DOWN,e.appid);break;case f.DOWN:n(f.PAUSE);a.notify(f.PAUSE,e.appid);break;case f.DOWN_END:n(f.SETUP);a.notify(f.SETUP,e.appid);break;case f.SETUP_END:a.notify(f.SETUP_END,e.appid);return true}return false};return require("Task").create().map({via:j.getPageVia(g==i.HOMESOCIAL||g==i.HOMEREC||g==i.SEARCHRESULT||g==i.BOUTIQUE?g:""),channelVia:j.getChannelVia(g),msgVia:j.getMsgVia(g),appInfo:l.getAppById(Math.abs(e.appid)),isInstall:e.isInstall!=undefined?e.isInstall:l.isInstall(e.pName)}).then(function(o){q=o.via+(g==i.HOMESOCIAL?"."+e.rank:"")+j.getSourceVia(e.appid,g),r=o.channelVia+j.getSourceVia(e.appid,g);msgVia=o.msgVia;k=o.appInfo;s=o.isInstall;t=i.DETAIL==p.channelId;u=i.ASSISTANT==p.channelId;if(!e.isUpdate&&e.pName&&s){return"isInstall"}if(!k){return true}if(e.isUpdate){return require("Task").create(l.getAppInfo(e.pName)).then(function(z){if(z&&require("Type").isArray(z)){var A=require("LocalAppFileds");if(parseInt(k.versionCode)==parseInt(z&&z[A.versionCode])){return true}return w()}})}return w()})}};a.init();return a});define("Event",function(){var b=require("Events").eventEmitter,a=new b();a.fire=function(){var m=require("Util"),e=String(arguments[0]);if(e.indexOf(".")>-1){e=e.split(".");var g=e[0],h=e[1],i=function(n,o,p,q){require("M").stringReport({errMsg:n,code:o,duration:p,reportRate:q||0})};switch(g){case"interface":var k=require("Type"),l=require("$"),d=arguments[1];k.isString(d)&&(d=l.parseJSON(d));if(d&&d.guid){var j=d.guid,f=require("Notify").getDuration(j);f=Date.now()-f;f>500&&i("namespace [ "+g+" ] notify method [ "+h+" ] Native call Time-consuming!",-430,f,1e4);d.ret==-1&&i("namespace [ "+g+" ] notify method [ "+h+" ] Native call cause Error!",d.ret,f)}require("AsyncInterface").emit(h,j,d);break}}else{this.emit.apply(this,arguments)}};var c=require("QzoneApp");c.fire=function(){a.fire.apply(a,arguments)};return a});define("Http",function(){var c=require("Config").http,a={guid:0,pool:{},_reqcallback:function(d,e){var g=this.pool[d.guid]||{},e=g[e],f=d.content?require("$").parseJSON(d.content.replace(/;$/,"")):{};d.extend&&(f=require("Util").extend(f,d.extend));e&&e.call(null,f,d.guid)},onError:function(d){d&&this._reqcallback(d,"error");var e=require("Api");require("Task").create(e.get("APNType",true)).then(function(f){e.showMsg(f>0?"服务器请求失败，请重试":"网络无连接")}).start()},onSuccess:function(d){d&&this._reqcallback(d,"success")},serializeParam:function(d){var f=require("Api"),e=null;return require("Task").create(f.getMobileInfo()).map(function(g){e=g;return{version:require("M").JSVersion||"0",from_h5:1}}).then(function(h){var i=require("Util"),g=[];d=i.extend(d,h);d.os_api_level=e.os_api_level;d.os_ver=e.os_ver;require("Util").each(d,function(j,k){g.push(k+"="+encodeURIComponent(j))});g=g.join("&");return g})},_send:function(d,e){require("Task").create(require("Api").get("Sid")).then(function(f){if(!f){a.onError({guid:d.guid,msg:"sid is Null"});return}var g=e.isGetUpdateApp?require("Config").app:c,h=e.isGetUpdateApp?"getUpdateApp":"httpRequest";require("Notify").pull(g,h,d).start()}).start()},loadJson:function(e){var d=e,f=d.id=++a.guid;this.pool[f]=d;require("Task").create(this.serializeParam(d.param)).then(function(g){d.url+=(d.url.indexOf("?")>-1?"&":"?")+g;a._send({guid:f,method:"GET",url:d.url,supportetag:0==e.supportetag?0:1},e)}).start();return f},formSubmit:function(e){var d=e,f=d.id=++a.guid;this.pool[f]=d;require("Task").create(this.serializeParam(d.param)).then(function(g){a._send({guid:f,method:"POST",url:d.url,params:d.param,supportetag:0==e.supportetag?0:1},e)}).start();return f}},b=require("Event");b.on("httpSuccess",function(){a.onSuccess.apply(a,arguments)});b.on("httpError",function(){a.onError.apply(a,arguments)});return a});define("ImgCache",function(){var b=require("Config").image,c=require("Events").eventEmitter,d=require("Collector"),a={SD_PATH:null,LOGO_PATH:null,PREVIEW_PATH:null,AD_PATH:null,IS_SD_MOUNT:null,pathMap:{logo:"app",preview:"big_imgs",ad:"ad"},imgPool:{},listener:{},collector:new d(1e3,10),evt:new c(),init:function(){var e=require("Event");e.on("loadImg",function(f){f=require("$").parseJSON(f);f=Array.prototype.slice.call(f,0);var g={app:a.renderLogoCb,big_imgs:a.renderPreviewCb,ad:a.renderAdCb};f&&require("Util").each(f,function(h){var i=g[h.path];i&&i.call(a,h.appid,h.path,h.localUrl,h.imgUrl)})});this.collector.on("fulled",this.downloadImageBatch)},on:function(e,f){this.evt.on(e,f)},notify:function(e){this.evt.emit.apply(this.evt,arguments)},getImgRootPath:function(){var f=require("Const"),e=this,g=function(h){var i="file:///";e.SD_PATH=i+h;e.LOGO_PATH=e.SD_PATH+e.pathMap.logo+"/";e.AD_PATH=e.SD_PATH+e.pathMap.ad+"/";e.PREVIEW_PATH=e.SD_PATH+e.pathMap.preview+"/";return true};return f.imgRoot?g(f.imgRoot):require("Task").create(require("Notify").pull(b,"getImageRootPath")).then(function(h){f.imgRoot=h;return g(h)})},isExist:function(e,f,g){return require("Task").create(require("Notify").pull(b,[f+"",this.pathMap[e]||"",g])).then(function(h){return 0==h})},getPrefix:function(e){return["http://i.gtimg.cn/open/app_icon/",("00000000"+e).substr(-8).match(/\d{2}/g).join("/")].join("")},downLoadImg:function(e,f,g){this.collector.push({path:a.pathMap[e]||"",url:f,del:g?"1":"0"})},downloadImageBatch:function(e){require("Notify").pull(b,"downloadImageBatch",[require("$").stringify(e),"1500","10"]).start()},delImg:function(e,f,g){require("Notify").pull(b,"clearImage",[e,f,g]).start()},getPic:function(e,f){return a.getPrefix(e)+"/"+f},getImgUrl:function(f,g,e){return f.toLowerCase()=="ad"?e:this.getPic(g,e)},getFileNameByUrl:function(e){var f=e.lastIndexOf("/");return f!=-1?e.substr(f+1).split(".")[0]:e},formatFileName:function(e){return"img_"+e.replace(/\./ig,"_")},getCache:function(e,f,h){e=e.toUpperCase();var g=f.lastIndexOf("."),i=g>0&&f.substr(g)||".png",j=a.getPicHash(e,f,h);return this[e+"_PATH"]+j+i},getPicHash:function(e,f,g){e=e.toUpperCase();(e=="PREVIEW"||e=="LOGO")&&(f=a.getPic(g,f));var h=require("Util").hash(f);return h},emptyFn:function(){},adOnload:function(e){e.setAttribute("onload","");e.style.display="";a.notify("success",e)},adOnerror:function(f){f.setAttribute("onerror","");f.style.display="none";var h=f.getAttribute("picid"),e=f.getAttribute("picurl"),i=a.getFileNameByUrl(e);f.onerror=function(){this.onerror=null;a.notify("error",h,a.pathMap.ad,e);e&&a.delImg("",a.pathMap.ad,e)};var g=require("Util").hash(e);if(a.imgPool[g]==1){return}a.imgPool[g]=1;e&&a.downLoadImg("ad",e,true)},renderAdCb:function(f,i,e,g){if(e){a.imgPool[a.getFileNameByUrl(e)]=0;var h="img_"+a.getFileNameByUrl(e);require("$")("."+h).each(function(){!this.getAttribute("loaded")&&(this.setAttribute("src","file:///"+e),this.setAttribute("loaded",1))})}else{a.notify("error",f,a.pathMap.ad,g)}},previewOnload:function(e){e.setAttribute("onload","");e.style.display="";a.notify("success",e);var f=e.getAttribute("picid"),h=e.getAttribute("picname"),g=a.getPic(f,h);f&&g&&a.downLoadImg("preview",g)},previewOnerror:function(f){f.setAttribute("onerror","");f.style.display="none";var h=f.getAttribute("picid"),i=f.getAttribute("picname"),e=a.getPic(h,i);f.onerror=function(){this.onerror=null;a.notify("error","",a.pathMap.preview,e);e&&a.delImg("",a.pathMap.preview,e)};var g=require("Util").hash(e);if(a.imgPool[g]==1){return}a.imgPool[g]=1;e&&a.downLoadImg("preview",e,true)},renderPreviewCb:function(f,i,e,g){if(e){a.imgPool[a.getFileNameByUrl(e)]=0;var h="img_"+a.getFileNameByUrl(e);require("$")("."+h).each(function(){!this.getAttribute("loaded")&&(this.onload=function(){this.onload=null;this.style.display="";a.notify("success",this)},this.setAttribute("src","file:///"+e),this.setAttribute("loaded",1))})}else{a.notify("error",f,a.pathMap.preview,g)}},logoOnload:function(e){if(e.getAttribute("_demand")==1){return}require("Task").create(require("Api").get("MobileInfo")).then(function(i){e.setAttribute("onload","");/DROID2|ME722/i.test(i.model_name)&&(e.style.display="none",e.clientHeight);e.style.display="";var g=e.getAttribute("picid"),j=e.getAttribute("picname"),f=a.getPic(g,j);e.src.indexOf("qapp_center_defaultlogo.png")>-1&&(e.onerror=function(){this.onerror=null;this.src="qapp_center_defaultlogo.png";g&&f&&a.delImg("",a.pathMap.logo,f)});if(e.getAttribute("loadDef")!=1){var h=require("Util").hash(f);if(a.imgPool[h]==1){return}a.imgPool[h]=1;g&&f&&a.downLoadImg("logo",f)}}).start()},logoOnerror:function(e){e.style.display="none";e.setAttribute("onerror","");var g=e.getAttribute("picid"),i=e.getAttribute("picname"),f=a.getPic(g,i);if(e.src.indexOf("qapp_center_defaultlogo.png")<0){var h=require("Util").hash(f);e.onerror=function(){this.onerror=null};e.src="qapp_center_defaultlogo.png";if(a.imgPool[h]==1){return}a.imgPool[h]=1;g&&f&&a.downLoadImg("logo",f,true)}},renderLogoCb:function(g,h,e,i){if(e){a.imgPool[a.getFileNameByUrl(e)]=0;var f="img_"+a.getFileNameByUrl(e);require("$")("."+f).each(function(){!this.getAttribute("loaded")&&(this.onload=function(){this.onload=null},this.setAttribute("src","file:///"+e),this.setAttribute("loaded",1))})}},getPicTmpl:function(e){e=e||{};var f="";switch(e.type.toLowerCase()){case"logo":if(e.picid){var g=e.picid+"_100_m.png";f=a.tmpl.logo({src:a.getCache("logo",g,e.picid),picid:e.picid,picname:g,className:e.className||"",loadDef:e.loadDef?1:0,lazyload:e.lazyload==false?false:true})}break;case"preview":e.picid&&e.picname&&(f=a.tmpl.preview({src:a.getCache("preview",e.picname,e.picid),picid:e.picid,picname:e.picname,extendAttr:e.extendAttr||""}));break;case"ad":e.picid&&e.picurl&&(f=a.tmpl.ad({src:a.getCache("ad",e.picurl,e.picid),picid:e.picid,picurl:e.picurl,extendAttr:e.extendAttr||""}));break}return f}};a.tmpl={};a.tmpl.logo=function(f){with(f||{}){var e=[],g=!loadDef&&lazyload?" _demand='1' _ori_src='"+src+"' ":"";e.push('<img pictype="LOGO" src="');e.push(loadDef||lazyload?"qapp_center_defaultlogo.png":src);e.push('" ');e.push(g);e.push(' onload="require(\'ImgCache\').logoOnload(this)" onerror="require(\'ImgCache\').logoOnerror(this)" picid="');e.push(picid);e.push('" loadDef="');e.push(loadDef);e.push('" picname="');e.push(picname);e.push('" class="');e.push(className);e.push(" img_");e.push(require("ImgCache").getPicHash("logo",picname,picid));e.push(' j_for_switch_mode j_for_render_pic" >');return e.join("")}};a.tmpl.preview=function(f){with(f||{}){var e=[];e.push('<img pictype="PREVIEW" src="');e.push(src);e.push('" onload="require(\'ImgCache\').previewOnload(this)" onerror="require(\'ImgCache\').previewOnerror(this)" picid="');e.push(picid);e.push('" picname="');e.push(picname);e.push('" class="img_');e.push(require("ImgCache").getPicHash("preview",picname,picid));e.push(' j_for_switch_mode j_for_render_pic" ');e.push(extendAttr);e.push(">");return e.join("")}};a.tmpl.ad=function(f){with(f||{}){var e=[];e.push('<img pictype="AD" src="');e.push(src);e.push('" onload="require(\'ImgCache\').adOnload(this)" onerror="require(\'ImgCache\').adOnerror(this)" picid="');e.push(picid);e.push('" picurl="');e.push(picurl);e.push('" class="img_');e.push(require("ImgCache").getPicHash("ad",picurl));e.push(' j_for_render_pic" ');e.push(extendAttr);e.push(" >");return e.join("")}};a.init();return a});define("Stat",function(){var b=require("Collector"),c=new b(2e3,10),d=new b(3e3,10),e="http://analy.qq.com/cgi-bin/mapp_apptrace?",a={reportBatch:function(f){setTimeout(function(){require("Notify").pull(require("Config").client,"reportForViaBatch",[require("$").stringify(f)]).start()},0)},sendByJsBatch:function(f){var g=require("Api"),h=[];require("Task").create().map({uin:g.get("Uin"),mobileInfo:g.get("MobileInfo")}).then(function(j){var i=j.mobileInfo,k={jsversion:require("M").JSVersion||"0",qua:i.qua,platform:i.platform,os_ver:i.os_ver,imei:i.imei,uin:j.uin,resolution:i.resolution,qz_ver:i.qz_ver,sdk_ver:"1.5",model_name:i.model_name,lang:i.language||"",network:i.network,ret_code:0,timezone:i.timezone,wifimac:i.wifimac,device:i.device,action:100,longitude:i.location||"",mobile_pf:1,appid_via_act_net_time_sender:f.join(",")};require("Util").each(k,function(l,m){h.push(m+"="+encodeURIComponent(l))});f&&f.length>0&&require("PingSender").send(e+h.join("&"))}).start()},sendByJs:function(f,g,h){d.push([h,g,f,require("Api").getMobileInfo().network,new Date().getTime(),0].join("_"))},send:function(f,g,h){c.push({actionType:f,via:g,appid:(h||require("Const").appid)+"",jsversion:require("M").JSVersion||"0"})},exposure:function(f,g,h){h?this.sendByJs("100",f,g):this.send("100",f,g)},click:function(f,g){this.send("200",f,g)},setup:function(f,g){this.send("300",f,g)},setupWebApp:function(f,g){setTimeout(function(){require("Notify").pull(require("Config").client,"reportStartApp",{via:f,appid:g+"",jsversion:require("M").JSVersion||"0",sender:0}).start()},50)},startApp:function(f,g){this.send("500",f,g)},autoStartApp:function(f,g){this.send("502",f,g)},cancelClick:function(f,g){this.send("700",f,g)},download:function(f,g){this.send("900",f,g)},unInstall:function(f,g){this.send("1000",f,g)},update:function(f,g){this.send("2000",f,g)}};c.on("fulled",a.reportBatch);d.on("fulled",a.sendByJsBatch);return a});define("Storage",function(){var a=require("Database"),b=require("Config").db,c={name:require("TableConfig").app_cache.name,getItem:function(d){var e=require("LocalStorage");if(e.support){return e.get(d)}else{return require("Task").create(a.select({select:"v",from:c.name,where:{k:d}})).then(function(f){if(!require("Const").enableWebDatabase){f=require("$").parseJSON(f);return f&&f.length>0?f[0][0]:""}else{return f&&f.length>0?f[0].item(0).v:""}})}},setItem:function(d,e){var f=require("LocalStorage");f.support?f.set(d,e):a.update({into:this.name,values:{k:d,v:e}})},delItem:function(d){a.del({from:this.name,where:{k:d}})},getMemValue:function(d){return require("Notify").pull(b,"getMemValue",[d])},setMemValue:function(d,e){require("Notify").pull(b,"setMemValue",[d,e]).start()}};return c});define("StorageMap",{message:"message_",need_new:"need_new_",finish_guide:"finish_guide_",social_max_count:"social_max_count_",myNotifyCount:"myNotifyCount_"});define("TableConfig",{app_cache:{name:"app_cache",version:3,sql:"create table if not exists app_cache (k varchar(50) PRIMARY KEY,v text);"},category:{name:"category",version:6,sql:"create table if not exists category (id varchar(50) PRIMARY KEY,v text);"},app:{name:"app",version:8,sql:"create table if not exists app (id INTEGER PRIMARY KEY,v text,imid varchar(30), pName varchar(200), ext text);"},user_info:{name:"user_info",version:2,sql:"create table if not exists user_info (id INTEGER(50), code INTEGER, friends TEXT, feeds TEXT, info TEXT,primary key (id,code));"}});define("Update",function(){var b="http://mapp.qzone.qq.com",a={url:b+"/cgi-bin/mapp/mapp_data",infourl:b+"/cgi-bin/mapp/mapp_info",privacyurl:b+"/cgi-bin/mapp/mapp_privacy",urlMap:{home:b+"/cgi-bin/mapp/mapp_home_qq",latest_used_app:b+"/cgi-bin/mapp/mapp_latest_used_app",hotnogame:b+"/cgi-bin/mapp/mapp_cate_qq",myapplist_v2:b+"/cgi-bin/mapp/mapp_mylist_qq",report:b+"/cgi-bin/mapp/mapp_report",topic:"http://mapp.qzone.qq.com/cgi-bin/mapp/mapp_topic"},updateTime:null,LOADLOCALDATA:true,BYDAY:false,CACHETIME:1e3*60*30,TOPIC_IDS:["essential_indexTopic","hot_indexTopic"],RELATIONPREFIX:"relationprefix",KEY:{home:"home",rec:"recommend",indexadv:"indexadvs",topic:"topic",hotnogame:"hotnogame",latestUsedApp:"latest_used_app",myapp:"myapplist",myapp_v2:"myapplist_v2",notify:"notify",message:"message"},needRefresh:false,retKey:{apps:"app",social:"social",advs:"advs",notify:"notify",message_count:"message_count",latestUsedApp:"latestUsedApp",updateapp:"updateapp",reportRate:"reportRate"},page:{},pageSize:20,getUpdateTime:function(){if(!this.updateTime){return require("Task").create(require("Storage").getItem("dataUpdateTime")).then(function(c){c=c?require("$").parseJSON(c):{};a.updateTime=c;return c})}return this.updateTime},saveUpdateTime:function(){require("Storage").setItem("dataUpdateTime",require("$").stringify(this.updateTime))},isNeedUpdate:function(e,d){d=d||1;var c=this,f=this.KEY.message==e?this.MSG_CACHETIME:this.CACHETIME;return require("Task").create(this._resetKey(e)).then(function(g){!c.updateTime[g]&&(c.updateTime[g]={});var i=new Date(c.updateTime[g][d]||0),j=new Date(),h=0,k=function(l){return l.getFullYear()+"-"+(l.getMonth()+1)+"-"+l.getDate()},h=j>i&&j-i>c.CACHETIME?1:0;return h})},setUpdateTime:function(e,f,d){var c=this;require("Task").create(this._resetKey(e)).then(function(g){!c.updateTime[g]&&(c.updateTime[g]={});c.updateTime[g][f]=d&&d*1e3||Date.now()}).start()},_resetKey:function(c){return require("Task").create(require("Api").get("Uin")).then(function(e){var d=a.KEY,f=c;c=(new RegExp("^("+d.indexadv+"|"+d.gamelistadv+"|"+d.nogamelistadv+")$")).test(c)?c:c+"_"+e;c=f==d.topic?c+"_"+this.topicId:c;return c})},_updateCategoryRelationData:function(g,e,d,f,c,h,i){c=this.RELATIONPREFIX+c;require("Task").create(require("Category").getCategory(c)).then(function(k){var l=a.KEY,n=require("Category").id,j=[];f=f,len=e&&e.length||0;if(len>0){l.topic==g&&require("Util").each(e,function(o){o&&j.push({id:o.id,columnid:o.columnid,columnname:o.columnname})});if(h){require("Category").setCategory(c,j)}else{var m=Math.max(0,d-1)*f;Array.prototype.splice.apply(k,[m,len].concat(j));require("Category").setCategory(c,k)}require("Category").setCateNext(c,d,i)}else{d==1&&(require("Category").setCategory(c,[]),require("Category").setCateNext(c,d,false))}}).start()},_updateCategoryData:function(e,f,g,c,h,i){var d=require("Category");require("Task").create(d.getCategory(c)).then(function(k){var m=d.id,l=e&&e.length||0,j=[];if(l>0||c==m.updateapp){require("App").add(e);require("Util").each(e,function(o){o&&j.push(o.id)});if(h){d.setCategory(c,j)}else{var n=Math.max(0,f-1)*g;Array.prototype.splice.apply(k,[n,l].concat(j));d.setCategory(c,k)}d.setCateNext(c,f,i)}}).start()},_updateData:function(j,l,d,f,t){var u=require("Util"),n=require("$"),c={},o=this,h=this.retKey,g=this.KEY,p=require("Category").id,m="";u.each(h,function(e){c[e]=f[e]});var q=p[j],d=d||this.page[j];switch(j){case g.home:var k=c[h.apps]||[],i=c[h.advs]||[];this._updateCategoryData(k,d,l,q,c.overwrite,f.next);i.length>0&&(require("Storage").setItem(g.indexadv,n.stringify(i)),this.setUpdateTime(g.indexadv,1,f.time));this.setUpdateTime(j,d,f.time);break;case g.topic:var k=c[h.apps]||[],i=c[h.advs]||[];j==g.topic&&this.TOPIC_IDS.indexOf(this.topicId)>-1&&this._updateCategoryRelationData(j,k,d,l,q,c.overwrite,f.next);this._updateCategoryData(k,d,l,q,c.overwrite,f.next);!!m&&i.length>0&&(require("Storage").setItem(m,require("$").stringify(i)),this.setUpdateTime(m,1,f.time));this.setUpdateTime(j,d,f.time);break;case g.hotnogame:!m&&(m=g.nogamelistadv);var k=c[h.apps]||[],i=c[h.advs]||[];this._updateCategoryData(k,d,l,q,c.overwrite,f.next);i.length>0&&(require("Storage").setItem(m,n.stringify(i)),this.setUpdateTime(m,1,f.time));this.setUpdateTime(j,d,f.time);break;case g.latestUsedApp:var s=c[h.latestUsedApp]||[],v=c[h.updateapp]||[],w=[];this._updateCategoryData(v,d,l,p.updateapp,true,f.next);d==1&&(c.overwrite=true,u.each(s,function(e){!!e.ismultipf&&w.push(e)}),this._updateCategoryData(w,d,l,p.myapp_pc,c.overwrite,f.next));this._updateCategoryData(s,d,l,q,c.overwrite,f.next);var x=[].concat(s,v);x.length>0&&this.setUpdateTime(j,d,f.time);break;case g.myapp_v2:var o=this,r=c[h.notify]||{update:[],pcapp:[]},y=c[h.message_count]||0;require("Task").create(require("Category").getCategory(p.updateapp)).then(function(e){var e=e||[];r&&!t.message_only&&(require("Task").create(require("Api").get("Uin")).then(function(A){require("Storage").setItem(p.notify+A,n.stringify(r))}).start(),o.setUpdateTime(g.notify,d,f.time));t.need_message&&(require("Task").create(require("Api").get("Uin")).then(function(A){require("Storage").setItem(require("StorageMap").message+A,n.stringify(y))}).start(),o.setUpdateTime(g.message,d,f.time));r.update=r.update||[];r.update.length!==e.length&&o.setUpdateTime(g.latestUsedApp,1,2649600)}).start();break}this.saveUpdateTime();if(c.reportRate){try{require("Task").create(require("Api").get("Uin")).then(function(e){window.localStorage&&localStorage.setItem("reportRate_"+e,encodeURIComponent(n.stringify(c.reportRate)))}).start()}catch(z){}require("M").stringReport.reportRate=parseInt(c.reportRate)}},getLocalData:function(f,n){var k=require("$"),i=require("App"),j=require("Category"),g=this.KEY,l=j.id,r=this,c={},e=l[f],d=n.pageNo,h=n.pageSize,q="",p=require("DfData"),o=false;c.dataVerify=true;var m=function(){!c.dataVerify&&r.saveUpdateTime();c.loadDefdata=o;return c};switch(f){case g.home:return require("Task").create().map({app:i.getAppsByCate(e,d,h,false),advs:require("Storage").getItem(g.indexadv),next:j.getCateNext(e,d)}).then(function(s){c.app=s.app||[];c.advs=k.parseJSON(s.advs)||[];c.next=s.next;(c.app.length==0||c.app.length!=h)&&1==d&&(o=true,c.app=p.home||[]);0==c.advs.length&&(o=true,c.advs=p.indexadv||[]);0==c.app.length&&(c.dataVerify=false,a.setUpdateTime(f,d,2649600));return m()});case g.hotnogame:!q&&(q=g.nogamelistadv);return require("Task").create().map({app:i.getAppsByCate(e,d,h,false),advs:require("Storage").getItem(g.indexadv),next:j.getCateNext(e,d)}).then(function(s){c.app=s.app||[];c.advs=k.parseJSON(s.advs)||[];c.next=s.next;20!=c.app.length&&10!=c.app.length&&1==d&&(o=true,c.app=p[f]||[]);0==c.app.length&&(c.dataVerify=false,a.setUpdateTime(f,d,2649600));return m()});case g.topic:return require("Task").create().map({app:i.getAppsByCate(e,d,h,true),next:j.getCateNext(e,d),cate:j.getCategory(a.RELATIONPREFIX+e)}).then(function(t){require("Util").log("debug update: getLocalData ctx="+require("$").stringify(t.cate));c.app=t.app||[];c.next=t.next;var u=t.cate||[];if(a.TOPIC_IDS.indexOf(a.topicId)>-1){var v=Math.max(0,d-1)*h;u=u.slice(v,v+h);for(var s=0;s<c.app.length;s++){c.app[s]=require("Util").extend(c.app[s],u[s]||{})}}0==c.app.length&&(c.dataVerify=false,a.setUpdateTime(f,d,2649600));return m()});case g.latestUsedApp:return require("Task").create(require("Api").get("Uin")).map(function(s){return{notify:require("Storage").getItem(l.notify+s),latestUsedApp:i.getAppsByCate(e,d,h),updateapp:i.getAppsByCate(l.updateapp),myappPc:i.getAppsByCate(l.myapp_pc),need:a.isNeedUpdate(f,d),next:j.getCateNext(e,d)}}).then(function(s){c.notify=k.parseJSON(s.notify)||{update:[],pcapp:[]};c.latestUsedApp=s.latestUsedApp||[];c.updateapp=s.updateapp||[];c.myappPc=s.myappPc||[];c.next=s.next;0==[].concat(c.latestUsedApp,c.updateapp)&&s.need&&(c.dataVerify=false,a.setUpdateTime(f,d,2649600));return m()});case g.myapp_v2:return require("Task").create(require("Api").get("Uin")).map(function(s){return{notify:require("Storage").getItem(l.notify+s),message_count:n.need_message?require("Storage").getItem(require("StorageMap").message+s):0}}).then(function(s){c.notify=k.parseJSON(s.notify)||{update:[],pcapp:[]};n.need_message&&(c.message_count=k.parseJSON(s.message_count)||0);return m()})}},loadData:function(c,A){var s=require("$"),k=require("Util"),i=require("Task"),u=require("Api"),m=require("Category"),g=A||{},h=this,d=this.KEY,w=this.retKey,l=m.id,e=g.param||{},n=e.pageSize||this.pageSize,x=!!e.pageNo,q="",r=false,j=false,C=false,v=false;c==d.topic&&(l[c]=g.idKey,this.topicId=e.topic_id,k.log("debug idkey:"+s.stringify(l[c])));!this.page[c]&&(this.page[c]=0);var f=e.pageNo||this.page[c]+1,t,p,B=e.need_message||0;i.create(this.getUpdateTime()).then(function(){if(d.myapp_v2==c&&e.notify_only){return i.create().map({need_notify:h.isNeedUpdate(d.notify,1),need_message:e.need_message?h.isNeedUpdate(d.message,1):false}).then(function(o){!o.need_notify&&o.need_message&&(p=1);return o.need_notify||o.need_message})}else{return h.isNeedUpdate(c,f)}}).map(function(o){t=o;return{need:t,mobileInfo:u.getMobileInfo()}}).then(function(D){e=k.extend({type:c,pageNo:f,pageSize:n,need_advertise:d.home==c?1:0},g.param);if(d.home==c){var o=D.mobileInfo;e=k.extend({imei:o.imei,mac_addr:o.wifimac,model_info:o.model_name||"",network_type:o.network||"",network_operater:o.mobileType||"",location:o.location||"",imsi:o.imsi||"",android_id:o.androidID||"",os_api_level:o.os_api_level||""},e)}i.create(z()).then(function(E){(v||E&&t)&&y()}).start()}).start();var y=function(){if(r){return}r=true;var G=false;e.firsttime=0;switch(c){case d.rec:case d.home:q=d.indexadv;e.need_friends=1;break;case d.hotnogame:q=d.nogamelistadv;break;case d.latestUsedApp:case d.myapp:case d.myapp_v2:break}var D=function(H){if(0==H.resultCode){var O=require("App"),J=require("Storage"),P=require("StorageMap"),L,M,N,K=[];i.create().map({uin:u.get("Uin"),oldList:m.getCategory(l[c],f,n),oldAdvs:1===e.need_advertise&&!H.advs&&q&&J.getItem(q),updateApps:d.latestUsedApp==c&&m.getCategory(l.updateapp),notify_resetKey:h._resetKey(d.notify)}).then(function(Q){L=Q.oldList;N=Q.notify_resetKey;M=s.parseJSON(Q.oldAdvs)||[];!x&&(h.page[c]=f);d.home==c&&f==1&&(H.social=H.social||[],H.app=H.social.concat(H.app),J.setItem(P.social_max_count+Q.uin,H.social.length));h._updateData(c,n,f,H,{message_only:p,need_message:B});1===e.need_advertise&&!H.advs&&q&&(H.advs=M);if(d.myapp_v2==c&&e.notify_only){j=false;i.create(p&&J.getItem(N)).then(function(S){p&&(H.notify=S&&s.parseJSON(S)||{update:[],pcapp:[]});!p&&(h.setUpdateTime(d.myapp_v2,1,2649600),h.saveUpdateTime());I()}).start();H.latest_num&&require("LocalStorage").set("latest_num",H.latest_num)}else if(d.latestUsedApp==c){i.create(J.getItem(N)).then(function(V){H.notify=s.parseJSON(V)||{};var S=H[w.latestUsedApp],T=[],W=Q.updateApps||[],U=[];k.each(S,function(X){X.id&&K.push(X.id);!!X.ismultipf&&U.push(X)});f==1&&(H.myappPc=U,k.each(H[w.updateapp],function(X){X.id&&T.push(X.id)}));L.join(",")!=K.join(",")||f==1&&W.join(",")!=T.join(",")?(u.setUrlParam("refresh","0"),H.overwrite=1,H.pageNo=f,j=false,f>1?i.create(m.getCategory(l[c])).then(function(X){X=X.slice(0,Math.max(0,f-1)*n);return O.getAppsByIds(X)}).then(function(X){H.latestUsedApp=X.concat(S);I()}).start():I()):I()}).start();H.latest_num&&require("LocalStorage").set("latest_num",H.latest_num)}else{d.home==c&&J.setItem(P.need_new+Q.uin,1);var R=H.app;k.each(R,function(S){S.id&&K.push(S.id)});!M&&f==1&&H.advs&&H.advs.length>0&&(H.overwrite=1,H.pageNo=f,j=false);L.join(",")!=K.join(",")||v?(H.overwrite=1,H.pageNo=f,j=false,f>1?i.create(m.getCategory(l[c])).then(function(S){S=S.slice(0,Math.max(0,f-1)*n);return O.getAppsByIds(S)}).then(function(S){if(a.TOPIC_IDS.indexOf(a.topicId)>-1){return i.create(m.getCategory(a.RELATIONPREFIX+l[c])).then(function(U){U=(U||[]).slice(0,Math.max(0,f-1)*n);for(var T=0,V=S.length;T<V;T++){S[T]=k.extend(k.extend({},S[T]),U[T]||[])}return S})}else{return S}}).then(function(S){H.app=S.concat(R);I()}).start():I()):I()}}).start();var I=function(){h.needRefresh&&(j=false);H.__isFromLocal=0;!j&&g.success&&g.success.call(null,H);j=true;r=false}}else{o(H);r=false}},o=function(H){H.__isFromLocal=0;!j&&(h.LOADLOCALDATA&&!g.errorFromLocal?(g.errorfromServer=true,z().start()):g.error&&g.error.call(null,H),j=true);r=false};if(d.myapp_v2==c&&!p||d.latestUsedApp==c){var E=function(){require("Http").formSubmit({isGetUpdateApp:true,url:h.urlMap[c],param:e,success:D,error:o})};e.update_data=0;E()}else{var F=e.url||h.urlMap[c];delete e.url;require("Http").loadJson({url:F,param:e,success:D,error:o})}},z=function(o){return i.create(h.getLocalData(c,e)).then(function(D){D.__isFromLocal=1;if(D.dataVerify){j=true;v=D.loadDefdata;!x&&(h.page[c]=f);g.success&&g.success.call(null,D,t);return true}else{!g.errorfromServer?(g.errorFromLocal=true,y()):g.error&&g.error.call(null,D);return false}})}},setPrivacyData:function(d,c){require("Http").formSubmit({url:this.privacyurl,param:{appid:d.id},success:function(e){0==e.resultCode?(d.friends.myprivacy=1,require("App").add(d),c.success&&c.success.call(null,e)):c.error&&c.error.call(null,e)},error:function(e){c.error&&c.error.call(null,e)}})},getAppFromServer:function(d,e){var f=require("Util"),c=e||{},g=f.extend({type:"appinfo",appid:d},c.param);d&&require("Http").loadJson({url:this.infourl,param:g,success:function(h){var i=require("App");0==h.resultCode?require("Task").create(i.getAppById(d)).then(function(k){var j=h.app&&h.app[0]||{};k=k||{};h.friendsplayed&&(j.friends=h.friendsplayed[0]||{});j.id?(delete j.playCount,j.userCount=Math.max(j.userCount,k.userCount||0),i.add(j),c.success&&c.success.call(null,h)):(h.msg="找不到这个应用哦",require("M").stringReport({errMsg:"Api.update.getAppFromServer appid : "+d+" load error. the appinfo in result is illegal",code:-502,duration:0}),c.error&&c.error.call(null,h))}).start():c.error&&c.error.call(null,h)},error:function(h){c.error&&c.error.call(null,h)}})},userAddApp:function(c,e,d){if(c){e?require("Stat").setupWebApp(e,c):require("Task").create(require("Api").get("Uin")).map(function(f){return{uin:f,isReport:require("Storage").getItem("record_"+c+"_"+f)}}).then(function(f){if(d=="install"){if(f.isReport){return}else{require("Storage").setItem("record_"+c+"_"+f.uin,1)}}require("Http").loadJson({url:"http://mapp.qzone.qq.com/cgi-bin/mapp/mapp_report",param:{type:"latest_used_app",appid:c,action:d&&encodeURIComponent(d)||""},success:function(g){0==g.resultCode}})}).start();return true}else{return false}}};return a});define("Init",function(){var a={start:function(){window.JsBridge=require("JsBridge");window.QzoneApp=require("QzoneApp");require(["DownloadBtn","TapEvent","BatchCallback"])}};return a});define("DownloadBtn",function(){var a={D_BTN:".pro_",D_PRO:" .d_pro",D_PRO_TEXT:" .d_pro_text",D_TEXT:" .d_text",D_STATE:" .d_state",D_SEARCH:" .d_search",D_COLOR_BTN:" .btn",COLOR_BTN_START:"btn-green",COLOR_BTN_OTHER:"btn-blue",CSS_SHOW_PRO:"show_pro",MSG:{"-1":"当前安装包出现问题或已被删除,请重新下载！","-2":"下载出错，请重试！","-3":"未发现存储卡，请检查后重试！","-4":"下载地址已更新,请重新下载！","-5":"网络无法连接，请检查网络并重试！","-6":"存储卡空间不足，请释放空间后重试！"},TEXT:{PAUSE:"下载中",DOWNLOAD:"下载",CONTINUE:"继续",INSTALL:"安装",UPDATE:"更新",START:"进入",WAIT:"等待中"},SEARCH_BTN:{"下载中":"ico-stop","下载":"ico-download","继续":"ico-start","安装":"ico-set","更新":"ico-reflash","进入":"ico-open","等待中":"ico-stop"},DEFALUT:true,init:function(){var b=require("Download");b.addListener(b.STATE.ALL,function(c,d){a.showState(c,d)})},preventDefault:function(){this.DEFALUT=false},setText:function(g,e,b){var c=this.D_BTN+g,d=require("$"),h=d(c+this.D_TEXT),f=d(c+this.D_COLOR_BTN),i=d(c+this.D_PRO),j=e;resultPro=b>=100?100.5:b;h.html(j);i.css("width",b+"%");e==this.TEXT.START?f.removeClass(this.COLOR_BTN_OTHER).addClass(this.COLOR_BTN_START):f.removeClass(this.COLOR_BTN_START).addClass(this.COLOR_BTN_OTHER)},updateProc:function(c,b,e){var d=parseInt(require("$")(this.D_BTN+c+this.D_TEXT).html())||0;!(d&&b<d)&&this.setText(c,e&&b==0?"下载中":b+"%",b)},_isShowIng:false,_showToast:function(b){!this._isShowIng&&(this._isShowIng=true,require("Api").showMsg(b),setTimeout(function(){a._isShowIng=false},3e3))},showState:function(f,o){if(!this.DEFALUT){return}var i=require("App"),g=require("Download"),d=g.STATE,j=g.PSTATE,b=f.appid,k=f.state,e=f.pro||0,m=parseInt(f.phony_pro)||0,h=g.getProState(b),n=f.ismyapp,c=this;e=Math.max(e,m);isNaN(e)&&(e=0);var l=function(){var p=j.INSTALL==h;p&&(b=0-b);var q=require("$")(c.D_BTN+b);if(k!=d.SETUP_END&&q.length<0){return false}switch(k){case d.DOWN:c.updateProc(b,e,n);break;case d.PAUSE:c.setText(b,c.TEXT.CONTINUE,e);break;case d.DOWN_END:c.setText(b,c.TEXT.INSTALL,100);break;case d.SETUP_END:case d.PACKAGE_REPLACE:c.setText(b,c.TEXT.START,0);break;case d.UNINSTALL_END:case d.CANCEL:c.setText(b,p?c.TEXT.UPDATE:c.TEXT.DOWNLOAD,0);break;case d.WAIT:c.setText(b,c.TEXT.WAIT,0);break}};!h?require("Task").create(i.getAppById(b)).then(function(p){if(p&&p.pName){return i.isInstall(p.pName)}else{return this.reject()}}).then(function(p){var q=i.getAppById(b);h=p?j.INSTALL:j.UNINSTALL;g.updateProState(b,h,true);l()}).start():l()}};a.init();return a});define("Page",function(){var a={touchTimer:null,dialogShowed:false,_preEvt:function(b){b&&(b.stopPropagation(),b.preventDefault())},detail:function(f,g){var b=g||{};this._preEvt(f);var d=["qapp_center_detail.htm?id="+b.appid],c=require("Channel"),e=require("Via");b.channelId=b.channelId||require("Const").channelId;b.openTime=Date.now();b.channelId==c.HOMESOCIAL&&(b.socialPos=b.rank);[c.TOPIC,c.CATEAPP,c.CATEGAME].indexOf(b.channelId)>=0&&!b.via?b.via=require("Topic").Const.via:b.channelId==c.BOUTIQUE&&(b.via=e.getSourceVia(b.appid,b.channelId),require("Task").create(e.getPageVia(b.channelId)).then(function(h){require("Stat").click(h+b.via,b.appid)}).start());require("Util").each(b,function(h,i){d.push(encodeURIComponent(i)+"="+encodeURIComponent(h))});b.url=d.join("&");require("Task").create(e.getChannelVia(b.channelId)).then(function(h){b.pName&&!/^[234]$/.test(b.tyqtype)?(b.url="sd://"+b.url,b.via=h+(b.via||""),b.myAppId=parseInt(b.myAppId,10)==0?"":b.myAppId,b.apkId=parseInt(b.apkId,10)==0?"":b.apkId,require("Api").goToDetailPage(b)):require("Api").openLocalUrl({url:d.join("&"),titleInfo:[{name:"应用详情",tipNum:0}]});b.channelId!=require("Channel").BOUTIQUE&&b.rank&&b.rank<51&&require("Task").create(require("Via").getPageVia(b.channelId)).then(function(i){require("Stat").click(i+".BLOCK."+b.rank,b.appid)}).start()}).start();return false},ad:function(d,e){var b=e||{};this._preEvt(d);b.type=b.type||0;var f={0:"",1:"sd://qapp_center_detail.htm"}[b.type]||"",g={0:"",1:"应用详情"}[b.type],c=f+(b.appurl.indexOf("?")>-1?"":"?")+b.appurl;c+=(c.indexOf("?")>-1?"&":"?")+"channelId="+b.channelId+"&adId="+b.adId;b.type==1?(b.url=c,require("Task").create(require("Via").getChannelVia(b.channelId)).then(function(h){b.via=h;b.appid=b.adId;require("Api").goToDetailPage(b)}).start()):b.appurl&&require("Api").openUrl({url:c,titleInfo:[{name:g,tipNum:0}]});return false},cate:function(b,c){this._preEvt(b);var d="qapp_center_cate.htm?channelId="+(c||require("Const").channelId)+"&openTime="+Date.now(),e={name:"应用分类",tipNum:0};return require("Api").openLocalUrl({url:d,titleInfo:e})},topic:function(b){this._preEvt(b.evt);var c="qapp_center_topic.htm?topicId="+b.topicId+"&channelId="+(b.channelId||require("Const").channelId)+"&key="+b.key+"&via="+(b.via||" ")+"&openTime="+Date.now(),d={name:require("Str").cutRealLen(b.name,20,"…"),tipNum:0};require("LocalStorage").set("tapPageStorageKey",b.key+b.topicId);return require("Api").openLocalUrl({url:c,titleInfo:d,shareData:"&topicId="+b.topicId+"&key="+b.key})},onlineTopic:function(c){this._preEvt(c.evt);var b=c.url,e={name:require("Str").cutRealLen(c.name,20,"…"),tipNum:0},d={uin:require("Api").get("Uin"),sid:require("Api").get("Sid"),mobileInfo:require("Api").getMobileInfo()};c.needUinSid&&(d.uin=require("Api").get("Uin"),d.sid=require("Api").get("Sid"));require("Task").create().map(d).then(function(f){var g=[];f.mobileInfo&&(g.push("os_ver="+f.mobileInfo.os_ver),g.push("resolution="+f.mobileInfo.resolution),g.push("os_api_level="+f.mobileInfo.os_api_level));b+=(b.indexOf("?")>=0?"&":"?")+g.join("&");g=[];f.uin&&g.push("uin="+f.uin);f.sid&&g.push("keystr="+encodeURIComponent(f.sid));b+=(b.indexOf("#")>=0?"&":"#")+g.join("&");require("Api").openUrl({url:b,titleInfo:e})}).start()},icon:function(d,e){var b=e||{};this._preEvt(d);var c=require("App");b.pName?require("Task").create(c.isInstall(b.pName)).then(function(f){f?c.startApp(b):a.detail(d,b)}).start():c.goWebApp(b);return false},category:function(c,d){var b=d||{};this._preEvt(c);var e="qapp_center_category.htm?type="+b.type+"&channelId="+(b.channelId||require("Const").channelId)+"&openTime="+Date.now(),f={nogame:[{name:"精品",tipNum:0}]},g=f[b.type];return require("Api").openLocalUrl({url:e,current:b.current,titleInfo:g})},info:function(b,c){this._preEvt(b);require("Api").openLocalUrl({url:"qapp_social_apps.html?channelId=10000&openTime="+Date.now(),titleInfo:[{name:"应用消息",tipNum:0}]})},myapp:function(c,d){var b=d||{};this._preEvt(c);require("Api").openLocalUrl({url:"qapp_center_myapp.htm?type="+b.type+"&index="+b.current+"&channelId="+(b.channelId||require("Const").channelId)+"&openTime="+Date.now(),titleInfo:[{name:"我的应用",tipNum:0}]})},btn:function(h,i){var b=i||{};this._preEvt(h);var d=require("App"),c=require("Via"),e=require("Task"),f=require("Stat"),g=function(){b.channelId==require("Channel").BOUTIQUE?e.create(c.getReportVia(b.channelId)).then(function(j){f.send(require("Channel").DETAIL!=require("Const").channelId?"210":"200",j+c.getSourceVia(b.appid,b.channelId),b.appid)}).start():b.rank&&b.rank<51&&e.create(c.getPageVia(b.channelId)).then(function(j){f.click(j+".DOWNLOAD."+b.rank,b.appid)}).start()};b.pName?(require("Notify").combineRequest=false,require("Task").create(require("Download").go(b)).then(function(j){j&&(j=="isInstall"?d.startApp(b):location.reload());require("Notify").combineRequest=true;g()}).start()):(d.goWebApp(b),g());return false},update:function(f,g){var b=g||{},c=require("Task"),d=require("Via"),e=require("Channel");this._preEvt(f);require("Notify").combineRequest=false;c.create(require("App").isInstall(b.pName)).then(function(h){b.isUpdate=true;b.isInstall=h;c.create(require("Download").go(b)).then(function(i){i&&(h?App.startApp(b):location.reload());require("Notify").combineRequest=true}).start();b.channelId==e.BOUTIQUE&&c.create(d.getReportVia(b.channelId)).then(function(i){require("Stat").send(e.DETAIL!=require("Const").channelId?"210":"200",i+d.getSourceVia(b.appid,b.channelId),b.appid)}).start()}).start()},reportErrMsg:function(c,d,f,g){var b="";c&&(c.stack&&(b=c.stack.split("\n"),b=b.slice(0,5).join("\n")),b=(g||"")+(b||c.message));b&&require("M").stringReport({errMsg:b,code:d,duration:f})},disActive:function(c){var d=require("$"),b=d(this);c.type=="touchmove"&&(clearTimeout(this.touchTimer),b.removeClass("active"),b.unbind("touchmove",a.disActive).unbind("touchend",a.disActive));b.unbind("touchmove",a.disActive).unbind("touchend",a.disActive);window.setTimeout(function(){b.removeClass("active")},200)},bindBtnActiveEvt:function(b,c){require("Util").delegate(b,"touchstart",function(f){var g=require("$"),d=g(this);f.stopPropagation();d.bind("touchmove",a.disActive).bind("touchend",a.disActive);this.touchTimer=setTimeout(function(){d.addClass("active")},100)},c)},getDocWidth:function(){return require("Task").create(require("Api").get("Display")).then(function(b){var c=document.documentElement.clientWidth,b=b.split("x"),d=(b[0]||0)/(devicePixelRatio||1);return c==d?c:d})},unique:function(c){var b=[];require("Util").each(c,function(d){b.indexOf(d)==-1&&b.push(d)});return b},getInstallMap:function(d){var c=require("Util"),b=[];c.each(d,function(e){e&&e.pName&&b.push(e.pName)});b=a.unique(b);return require("Task").create(require("App").isInstall(b)).then(function(f){var g=f.split(","),e={};c.each(g,function(h,j){e[b[j]]=h});return e||{}})},getInstallAppids:function(b,c){return require("Task").create(c||this.getInstallMap(b)).then(function(f){var d=[],e=[];require("Util").each(b,function(g){if(g&&g.id){var i=1==f[g.pName];i?d.push(g.id):e.push(g.id);var h=require("Download");h.updateProState(g.id,i?h.PSTATE.INSTALL:h.PSTATE.UNINSTALL,true)}});e=a.unique(e);d=a.unique(d);return{appidsNotInstall:e,appidsInstalled:d}})}};return a});define("Channel",{HOME:"1000",HOMESOCIAL:"3000",HOMEADV:"1003",HOMEREC:"2000",SEARCH:"1001",SEARCHRESULT:"1001_1",DETAIL:"1006",GUESS:"1022",GAME:"2100",HOTGAME:"2101",NEWGAME:"2102",GAMEADV:"2103",NOGAME:"2200",HOTNOGAME:"2201",NEWNOGAME:"2202",NOGAMEADV:"2203",MYAPP:"1004",UPDATE:"1011",MYAPPLIST:"2301",MYAPPLIST_NONE:"2301_1",MYAPPLIST_PC:"2301_2",MYAPPLIST_H5:"2301_3",MYAPPLIST_NATIVE:"2301_4",UPDATELIST:"2302",UPDATELIST_NONE:"2302_1",NOTIFICATION:"2400",ALLAPPLIST:"2500",STORE_NEW:"2001",STORE_NORMAL:"2002",PCPUSH_2G3GDIALOG:"2459",_2G3GDIALOG:"2600",FREEGIFT:"1",BRAG:"52",PK:"53",INVITE:"100",PCPUSH_NOTIFY:"56",PCPUSH_AUTO:"57",ASSISTANT:"4000",GDTFEEDS:"10000",TOPIC:"4001",INDEXTOPICNEC:"5000",INDEXTOPICHOT:"5001",CATE:"6000",CATEAPP:"6001",CATEGAME:"6002",BOUTIQUE:"8000"});define("Via",function(){var a={pageVia:{1000:".STORE.HOME",2000:".STORE.HOME.RECOMMEND",3000:".STORE.HOME.SOCIAL",8000:".STORE.HOME.RECOMMEND",10000:".",1001:".STORE.SEARCH","1001_1":".STORE.SEARCH.RESULT",1006:".STORE.APPDETAIL",1022:".STORE.APPDETAIL.GUESSLIST",2100:".STORE.GAMELIST",2101:".STORE.GAMELIST.HOT",2102:".STORE.GAMELIST.NEW",2200:".STORE.APPLIST",2201:".STORE.APPLIST.HOT",2202:".STORE.APPLIST.NEW",1004:".STORE.MYAPP",2301:".STORE.MYAPP.APPLIST","2301_1":".STORE.MYAPP.APPLIST.NOAPP","2301_2":".STORE.MYAPP.APPLIST.PCAPPLIST","2301_3":".STORE.MYAPP.APPLIST.H5APPLIST","2301_4":".STORE.MYAPP.APPLIST.NATIVEAPPLIST",2302:".STORE.MYAPP.UPDATELIST.APPLIST","2302_1":".STORE.MYAPP.UPDATELIST.NOAPP",2410:".STORE.APPDETAIL.MIG",2500:".STORE.BOUTIQUE",2001:".STORE.ASSISTANT.STORE.NEW",2002:".STORE.ASSISTANT.STORE.NORMAL",4001:".STORE.TOPIC.",5000:".STORE.NECESSARY",5001:".STORE.HOTRECOMMEND",5002:".STORE.FIRSTRELEASE",5003:".STORE.GIFTCENTER",6000:".STORE.CATEGORY",6001:".STORE.APP.",6002:".STORE.GAME."},channelVia:{1003:".STORE.APPDETAIL.HOME.ADS.","1001_1":".STORE.APPDETAIL.SEARCH.RESULT",1004:".STORE.APPDETAIL.MYAPP.APPLIST",1011:".STORE.APPDETAIL.MYAPP.UPDATELIST",1022:".STORE.APPDETAIL.GUESSLIST",2000:".STORE.APPDETAIL.HOME.RECOMMEND",3000:".STORE.APPDETAIL.HOME.SOCIAL.",8000:".STORE.APPDETAIL.HOME.RECOMMEND",2101:".STORE.APPDETAIL.GAMELIST.HOT",2102:".STORE.APPDETAIL.GAMELIST.NEW",2103:".STORE.APPDETAIL.GAMELIST.ADS.",2201:".STORE.APPDETAIL.APPLIST.HOT",2202:".STORE.APPDETAIL.APPLIST.NEW",2203:".STORE.APPDETAIL.APPLIST.ADS.","2301_1":".STORE.APPDETAIL.MYAPP.APPLIST.NOAPP","2301_2":".STORE.APPDETAIL.MYAPP.APPLIST.PCAPPLIST","2301_3":".STORE.APPDETAIL.MYAPP.APPLIST.H5APPLIST","2301_4":".STORE.APPDETAIL.MYAPP.APPLIST.NATIVEAPPLIST","2302_1":".STORE.APPDETAIL.MYAPP.UPDATELIST.NOAPP",2400:".STORE.APPDETAIL.DOWNLOADPUSH",2410:".STORE.APPDETAIL.MIG",2456:".STORE.APPDETAIL.PCPUSH",2457:".STORE.APPDETAIL.PCPUSH.AIOMSG",2458:".STORE.APPDETAIL.PCPUSH.MSGPUSH",2459:".STORE.APPDETAIL.PCPUSH.2G3GDIALOG","2460_1":".FREEGIFT.APPAIO.APPDETAIL","2460_50":".REQUEST.APPAIO.APPDETAIL","2460_52":".BRAG.APPAIO.APPDETAIL","2460_53":".PK.APPAIO.APPDETAIL","2460_100":".INVITE.APPAIO.APPDETAIL",2461:".STORE.APPDETAIL.SHARE-APP",2500:".STORE.APPDETAIL.BOUTIQUE",2600:".STORE.2G3GDIALOG",1:".FREEGIFT.ASSISTANT.APPDETAIL",50:".REQUEST.ASSISTANT.APPDETAIL",52:".BRAG.ASSISTANT.APPDETAIL",53:".PK.ASSISTANT.APPDETAIL",56:".PCPUSH.NOTIFY.ASSISTANT.APPDETAIL",57:".PCPUSH.AUTO.ASSISTANT.APPDETAIL",58:".VOICE.ASSISTANT.APPDETAIL",100:".INVITE.ASSISTANT.APPDETAIL","200_1":".SENDSTORY.FEED1.APPDETAIL","200_2":".SENDSTORY.FEED2.APPDETAIL","100_1":".INSTALL.FEED.APPDETAIL","300_0":".STORE.ASSISTANT.STATEMSG.RECOMMEND.01","300_1":".STORE.ASSISTANT.STATEMSG.RECOMMEND.02","300_2":".STORE.ASSISTANT.STATEMSG.RECOMMEND.03","300_3":".STORE.ASSISTANT.STATEMSG.RECOMMEND.04","300_4":".STORE.ASSISTANT.STATEMSG.RECOMMEND.05","300_5":".STORE.ASSISTANT.STATEMSG.RECOMMEND.06","400_0":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.01","400_1":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.02","400_2":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.03","400_3":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.04","400_4":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.05","400_5":".STORE.ASSISTANT.STATENOMSG.RECOMMEND.06",10000:".",4001:".STORE.APPDETAIL.TOPIC.",5000:".STORE.APPDETAIL.NECESSARY",5001:".STORE.APPDETAIL.HOTRECOMMEND",5002:".STORE.APPDETAIL.FIRSTRELEASE",5003:".STORE.APPDETAIL.GIFTCENTER",6001:".STORE.APPDETAIL.APP.",6002:".STORE.APPDETAIL.GAME.","-10000":".STORE.APPDETAIL.STARTERROR","-100000":".STORE.APPDETAIL.UNKNOW"},channelExposureVia:{1:".STORE.APPDETAIL.FREEGIFT.ASSISTANT",50:".STORE.APPDETAIL.REQUEST.ASSISTANT",52:".STORE.APPDETAIL.BRAG.ASSISTANT",53:".STORE.APPDETAIL.PK.ASSISTANT",58:".STORE.APPDETAIL.VOICE.ASSISTANT",100:".STORE.APPDETAIL.INVITE.ASSISTANT",10000:".","2460_1":".STORE.APPDETAIL.FREEGIFT.APPAIO","2460_50":".STORE.APPDETAIL.REQUEST.APPAIO","2460_52":".STORE.APPDETAIL.BRAG.APPAIO","2460_53":".STORE.APPDETAIL.PK.APPAIO","2460_100":".STORE.APPDETAIL.INVITE.APPAIO",2456:".STORE.APPDETAIL.PCPUSH",2457:".STORE.APPDETAIL.PCPUSH.AIOMSG",2458:".STORE.APPDETAIL.PCPUSH.MSGPUSH","200_1":".STORE.APPDETAIL.SENDSTORY.FEED1","200_2":".STORE.APPDETAIL.SENDSTORY.FEED2","100_1":".STORE.APPDETAIL.INSTALL.FEED","300_1":".STORE.APPDETAIL.RECOMMEND.01.ASSISTANT","300_2":".STORE.APPDETAIL.RECOMMEND.02.ASSISTANT","300_3":".STORE.APPDETAIL.RECOMMEND.03.ASSISTANT","300_4":".STORE.APPDETAIL.RECOMMEND.04.ASSISTANT","300_5":".STORE.APPDETAIL.RECOMMEND.05.ASSISTANT","300_6":".STORE.APPDETAIL.RECOMMEND.06.ASSISTANT","400_1":".STORE.APPDETAIL.RECOMMEND.01.ASSISTANT","400_2":".STORE.APPDETAIL.RECOMMEND.02.ASSISTANT","400_3":".STORE.APPDETAIL.RECOMMEND.03.ASSISTANT","400_4":".STORE.APPDETAIL.RECOMMEND.04.ASSISTANT","400_5":".STORE.APPDETAIL.RECOMMEND.05.ASSISTANT","400_6":".STORE.APPDETAIL.RECOMMEND.06.ASSISTANT"},state:{DOWN:".TODOWNLOAD",INSTALL:".TOINSTALL",UPDATE:".TOUPDATE",AUTOSTART:".TOAUTOSTART",OPEN:".TOOPEN"},getState:function(b){return this.state[b]},setTopicVia:function(){var b={};return function(c,d){!b[c]&&(a.channelVia[c]+=d,a.pageVia[c]+=d,b[c]=1)}}(),setChannelAdId:function(b){this.channelVia["1003"]+=b;this.channelVia["2103"]+=b;this.channelVia["2203"]+=b},setChannelSocialId:function(b){this.channelVia["3000"]+=b},getPageVia:function(b){var c=require("Const");if(require("Channel").ASSISTANT==c.channelId){return this.getMsgVia(b)}else{return require("Task").create(require("Api").get("Platform")).then(function(d){return d.toUpperCase()+a.pageVia[b||c.channelId]})}},getChannelVia:function(c,b,d,e){var f=require("Const");return require("Task").create(require("Api").get("Platform")).then(function(g){return g.toUpperCase()+((b?a.channelExposureVia[c||f.channelId]:null)||a.channelVia[c||f.channelId]||a.channelVia["-100000"])+(e?e:"")+(d?d:"")+(b?a.getState(b):"")})},getReportVia:function(b,d){var c=require("Channel");return require("Task").create().map({platform:require("Api").get("Platform"),pageVia:a.getPageVia(b==c.HOMESOCIAL||b==c.HOMEREC||b==c.SEARCHRESULT||b==c.BOUTIQUE?b:""),channelVia:a.getChannelVia(b),infoVia:a.getMsgVia(b)}).then(function(e){var f=e.pageVia+(b==c.HOMESOCIAL?"."+d:""),g=e.channelVia,h=e.infoVia;return c.DETAIL==require("Const").channelId?g:f!=e.platform.toUpperCase()?f:h})},getMsgChannelVia:function(b){var c={1:".STORE.ASSISTANT.FREEGIFT.PUSH",50:".STORE.ASSISTANT.REQUEST.PUSH",52:".STORE.ASSISTANT.BRAG.PUSH",53:".STORE.ASSISTANT.PK.PUSH",56:".STORE.ASSISTANT.PCPUSH.NOTIFY.PUSH",57:".STORE.ASSISTANT.PCPUSH.AUTO.PUSH",58:".STORE.ASSISTANT.VOICE.PUSH",100:".STORE.ASSISTANT.INVITE.PUSH",2480:".STORE.ASSISTANT.MINIBOX",10000:".STORE.ASSISTANT.MYQZ",3001:".STORE.MSGCARDS"}[b]||"";return require("Task").create(require("Api").get("Platform")).then(function(d){return d.toUpperCase()+c||""})},getMsgVia:function(b){var c={1:".FREEGIFT.ASSISTANT",50:".REQUEST.ASSISTANT",52:".BRAG.ASSISTANT",53:".PK.ASSISTANT",56:".PCPUSH.NOTIFY.ASSISTANT",57:".PCPUSH.AUTO.ASSISTANT",58:".VOICE.ASSISTANT",100:".INVITE.ASSISTANT"}[b]||"";return require("Task").create(require("Api").get("Platform")).then(function(d){return d.toUpperCase()+c||""})},getSourceVia:function(b){return""}};return a});define("MyNotify",function(){var a={modified:function(d,e,f){var g=0,b="",c="";return require("Task").create(require("Api").get("Uin")).map(function(h){var i=require("Storage");b="notifylist_"+h,c="notifyCount_"+h;return{uin:h,old:i.getItem(b),notify:d||i.getItem(require("Category").id.notify+h),currentFlag:i.getItem(c)}}).then(function(k){var l=require("$"),o=require("Util"),p=require("Storage"),n=false,m=l.parseJSON(k.old)||{update:[],pcapp:[]},h=!require("Type").isString(k.notify)?k.notify:l.parseJSON(k.notify)||{update:[],pcapp:[]},i=l.parseJSON(k.flagKey)||{update:0,pcapp:0},j={update:o.removeFromArray([].concat(h.update),[].concat(m.update)).length,pcapp:o.removeFromArray([].concat(h.pcapp),[].concat(m.pcapp)).length},q=function(r){r==e&&f?(i[r]=0,j[r]=0,n=true,m[r]=h[r]):i[r]||j[r]?i[r]=j[r]:i==0&&diffCount==0&&(i[r]=0,j[r]=0,n=true,m[r]=h[r])};q("update");q("pcapp");p.setItem(c,l.stringify(i));n&&p.setItem(b,l.stringify(m));return{pcappCount:j.pcapp!=0?h.pcapp.length:0,updateCount:j.update!=0?h.update.length:0}})}};return a});define("CateList",function(){var a={url:"http://mapp.qzone.qq.com/cgi-bin/mapp/mapp_catelist_qq",key:"cateList_",LOADLOCALDATA:true,CACHETIME:1e3*60*60*12,getClassData:function(e,f,g){var d=0,j=e.type,b=this.key+j,c=require("$").parseJSON(require("LocalStorage").get(b));!!c&&f({cateList:c||[]});var h=require("LocalStorage").get(b+"UpdateTime")||0,i=Date.now();d=i>h&&i-h>this.CACHETIME?1:0;!c&&(d=1);d&&require("Http").loadJson({url:this.url,param:e,success:function(k){k&&k.cateList&&k.cateList.length>0?(require("LocalStorage").set(b,require("$").stringify(k.cateList)),require("LocalStorage").set(b+"UpdateTime",Date.now()),f(k)):g(k)},error:function(k){!c&&g(k)}})}};return a});
